#!/usr/bin/python
import cgi
import commands
import os
import string

# Global definitions
colors = {
    1:"ff0000",2:"0000ff",3:"00ff00",5:"FFFF00",4:"00DDDD",6:"FF00FF",
    7:"af7817",8:"7931df",9:"980517",10:"578693",11:"f76541",12:"f5f3d7",
    13:"e18b6b",14:"7d1b7e",15:"4e9258",16:"b7ad59",17:"3bb9ff", 18:"d4a017",
    19:"f52887",20:"3b9c99" 
    }
rrd_periods = {
    'day':'1d', '3days':'3d', 'week':'1w', '2weeks':'2w', 'month':'1mon',
    '3months':'3mon', 'year':'1y'}

proc_types = ['short', 'medium', 'long', 'total']
ds_proc_types = {
    'short':'NrS',
    'medium':'NrM',
    'long':'NrL',
    'total':'NrT'
    }

utility_nodes = {
    1:'fcdfhead1',
    2:'fcdfhead2',
    3:'fcdfmon1',
    4:'fcdfcode1',
    5:'fcdflnx1',
    6:'fcdflnx2',
    7:'fcdflnx3'
    }

servers = {
     1:'fcdfdata001',  2:'fcdfdata002',  3:'fcdfdata003',  4:'fcdfdata004',
     5:'fcdfdata005',  6:'fcdfdata006',  7:'fcdfdata007',  8:'fcdfdata008',
     9:'fcdfdata009', 10:'fcdfdata010', 11:'fcdfdata011', 12:'fcdfdata012',
    13:'fcdfdata013', 14:'fcdfdata014', 15:'fcdfdata015', 16:'fcdfdata016',
    17:'fcdfdata017', 18:'fcdfdata018', 19:'fcdfdata019', 20:'fcdfdata020',
    21:'fcdfdata021', 22:'fcdfdata022', 23:'fcdfdata023', 24:'fcdfdata024',
    25:'fcdfdata025', 26:'fcdfdata026', 27:'fcdfdata027', 28:'fcdfdata028',
    29:'fcdfdata029', 30:'fcdfdata030', 31:'fcdfdata031', 32:'fcdfdata032',
    33:'fcdfdata033', 34:'fcdfdata034', 35:'fcdfdata035', 36:'fcdfdata036',
    37:'fcdfdata037', 38:'fcdfdata038', 39:'fcdfdata039', 40:'fcdfdata040',
    41:'fcdfdata041', 42:'fcdfdata042', 43:'fcdfdata043', 44:'fcdfdata044',
    45:'fcdfdata045', 46:'fcdfdata046', 47:'fcdfdata047', 48:'fcdfdata048',
    49:'fcdfdata049', 50:'fcdfdata050', 51:'fcdfdata051', 52:'fcdfdata052',
    53:'fcdfdata053', 54:'fcdfdata054', 55:'fcdfdata055', 56:'fcdfdata056',
    57:'fcdfdata057', 58:'fcdfdata058', 59:'fcdfdata059', 60:'fcdfdata060',
    61:'fcdfdata061', 62:'fcdfdata062', 63:'fcdfdata063', 64:'fcdfdata064',
    65:'fcdfdata065', 66:'fcdfdata066', 67:'fcdfdata067', 68:'fcdfdata068',
    69:'fcdfdata069', 70:'fcdfdata070', 71:'fcdfdata071', 72:'fcdfdata072',
    73:'fcdfdata073', 74:'fcdfdata074', 75:'fcdfdata075', 76:'fcdfdata076',
    77:'fcdfdata077', 78:'fcdfdata078', 79:'fcdfdata079', 80:'fcdfdata080',
    81:'fcdfdata081', 82:'fcdfdata082', 83:'fcdfdata083', 84:'fcdfdata084',
    85:'fcdfdata085', 86:'fcdfdata086', 87:'fcdfdata087', 88:'fcdfdata088',
    89:'fcdfdata089', 90:'fcdfdata090', 91:'fcdfdata091'
    }

dCache_servers = {
      1:'fcdfdata008',  2:'fcdfdata009',  3:'fcdfdata010',  4:'fcdfdata011',
      5:'fcdfdata017',  6:'fcdfdata018',  7:'fcdfdata019',  8:'fcdfdata020',
      9:'fcdfdata021', 10:'fcdfdata022', 11:'fcdfdata023', 12:'fcdfdata024',
     13:'fcdfdata035', 14:'fcdfdata036', 15:'fcdfdata037', 16:'fcdfdata038',
     17:'fcdfdata039', 18:'fcdfdata040', 19:'fcdfdata052', 20:'fcdfdata053',
     21:'fcdfdata054', 22:'fcdfdata055', 23:'fcdfdata056', 24:'fcdfdata057',
     25:'fcdfdata058', 26:'fcdfdata059', 27:'fcdfdata060', 28:'fcdfdata061',
     29:'fcdfdata062', 30:'fcdfdata063', 31:'fcdfdata064', 32:'fcdfdata065',
     33:'fcdfdata066', 34:'fcdfdata067', 35:'fcdfdata068', 36:'fcdfdata069',
     37:'fcdfdata070', 38:'fcdfdata071', 39:'fcdfdata072', 40:'fcdfdata073',
     41:'fcdfdata074', 42:'fcdfdata075', 43:'fcdfdata076', 44:'fcdfdata077',
     45:'fcdfdata078', 46:'fcdfdata079', 47:'fcdfdata080', 49:'fcdfdata081',
     51:'fcdfdata082', 52:'fcdfdata083'
    }

stage1_static_servers = {
     1:'fcdfdata001',  2:'fcdfdata002',  3:'fcdfdata003',  4:'fcdfdata004',
     5:'fcdfdata005',  6:'fcdfdata006',  7:'fcdfdata015'
    }

stage2_static_servers = {
     1:'fcdfdata076',  2:'fcdfdata077',  3:'fcdfdata078',  4:'fcdfdata080',
     5:'fcdfdata081',  6:'fcdfdata082',  7:'fcdfdata083',  8:'fcdfdata084',
     9:'fcdfdata085', 10:'fcdfdata086', 11:'fcdfdata087', 12:'fcdfdata088'
    }

stage1_worker_nodes = {
     1:'fcdfcaf001',  2:'fcdfcaf002',  3:'fcdfcaf003',  4:'fcdfcaf004',
     5:'fcdfcaf005',  6:'fcdfcaf006',  7:'fcdfcaf007',  8:'fcdfcaf008',
     9:'fcdfcaf009', 10:'fcdfcaf010', 11:'fcdfcaf011', 12:'fcdfcaf012',
    13:'fcdfcaf013', 14:'fcdfcaf014', 15:'fcdfcaf015', 16:'fcdfcaf016',
    17:'fcdfcaf017', 18:'fcdfcaf018', 19:'fcdfcaf019', 20:'fcdfcaf020',
    21:'fcdfcaf021', 22:'fcdfcaf022', 23:'fcdfcaf023', 24:'fcdfcaf024',
    25:'fcdfcaf025', 26:'fcdfcaf026', 27:'fcdfcaf027', 28:'fcdfcaf028',
    29:'fcdfcaf029', 30:'fcdfcaf030', 31:'fcdfcaf031', 32:'fcdfcaf032',
    33:'fcdfcaf033', 34:'fcdfcaf034', 35:'fcdfcaf035', 36:'fcdfcaf036',
    37:'fcdfcaf037', 38:'fcdfcaf038', 39:'fcdfcaf039', 40:'fcdfcaf040',
    41:'fcdfcaf041', 42:'fcdfcaf042', 43:'fcdfcaf043', 44:'fcdfcaf044',
    45:'fcdfcaf045', 46:'fcdfcaf046', 47:'fcdfcaf047', 48:'fcdfcaf048',
    49:'fcdfcaf049', 50:'fcdfcaf050', 51:'fcdfcaf051', 52:'fcdfcaf052',
    53:'fcdfcaf053', 54:'fcdfcaf054', 55:'fcdfcaf055', 56:'fcdfcaf056',
    57:'fcdfcaf057', 58:'fcdfcaf058', 59:'fcdfcaf059', 60:'fcdfcaf060',
    61:'fcdfcaf061', 62:'fcdfcaf062', 63:'fcdfcaf063', 64:'fcdfcaf064',
    65:'fcdfcaf065', 66:'fcdfcaf066', 67:'fcdfcaf067'
    }

worker_nodes = {
      1:'fcdfcaf001',   2:'fcdfcaf002',   3:'fcdfcaf003',   4:'fcdfcaf004',
      5:'fcdfcaf005',   6:'fcdfcaf006',   7:'fcdfcaf007',   8:'fcdfcaf008',
      9:'fcdfcaf009',  10:'fcdfcaf010',  11:'fcdfcaf011',  12:'fcdfcaf012',
     13:'fcdfcaf013',  14:'fcdfcaf014',  15:'fcdfcaf015',  16:'fcdfcaf016',
     17:'fcdfcaf017',  18:'fcdfcaf018',  19:'fcdfcaf019',  20:'fcdfcaf020',
     21:'fcdfcaf021',  22:'fcdfcaf022',  23:'fcdfcaf023',  24:'fcdfcaf024',
     25:'fcdfcaf025',  26:'fcdfcaf026',  27:'fcdfcaf027',  28:'fcdfcaf028',
     29:'fcdfcaf029',  30:'fcdfcaf030',  31:'fcdfcaf031',  32:'fcdfcaf032',
     33:'fcdfcaf033',  34:'fcdfcaf034',  35:'fcdfcaf035',  36:'fcdfcaf036',
     37:'fcdfcaf037',  38:'fcdfcaf038',  39:'fcdfcaf039',  40:'fcdfcaf040',
     41:'fcdfcaf041',  42:'fcdfcaf042',  43:'fcdfcaf043',  44:'fcdfcaf044',
     45:'fcdfcaf045',  46:'fcdfcaf046',  47:'fcdfcaf047',  48:'fcdfcaf048',
     49:'fcdfcaf049',  50:'fcdfcaf050',  51:'fcdfcaf051',  52:'fcdfcaf052',
     53:'fcdfcaf053',  54:'fcdfcaf054',  55:'fcdfcaf055',  56:'fcdfcaf056',
     57:'fcdfcaf057',  58:'fcdfcaf058',  59:'fcdfcaf059',  60:'fcdfcaf060',
     61:'fcdfcaf061',  62:'fcdfcaf062',  63:'fcdfcaf063',  64:'fcdfcaf064',
     65:'fcdfcaf065',  66:'fcdfcaf066',  67:'fcdfcaf067',
     68:'fcdfcaf068',  69:'fcdfcaf069',  70:'fcdfcaf070',  71:'fcdfcaf071', 
     72:'fcdfcaf072',  73:'fcdfcaf073',  74:'fcdfcaf074',  75:'fcdfcaf075', 
     76:'fcdfcaf076',  77:'fcdfcaf077',  78:'fcdfcaf078',  79:'fcdfcaf079', 
     80:'fcdfcaf080',  81:'fcdfcaf081',  82:'fcdfcaf082',  83:'fcdfcaf083', 
     84:'fcdfcaf084',  85:'fcdfcaf085',  86:'fcdfcaf086',  87:'fcdfcaf087', 
     88:'fcdfcaf088',  89:'fcdfcaf089',  90:'fcdfcaf090',  91:'fcdfcaf091', 
     92:'fcdfcaf092',  93:'fcdfcaf093',  94:'fcdfcaf094',  95:'fcdfcaf095', 
     96:'fcdfcaf096',  97:'fcdfcaf097',  98:'fcdfcaf098',  99:'fcdfcaf099', 
    100:'fcdfcaf100', 101:'fcdfcaf101', 102:'fcdfcaf102', 103:'fcdfcaf103', 
    104:'fcdfcaf104', 105:'fcdfcaf105', 106:'fcdfcaf106', 107:'fcdfcaf107', 
    108:'fcdfcaf108', 109:'fcdfcaf109', 110:'fcdfcaf110', 111:'fcdfcaf111', 
    112:'fcdfcaf112', 113:'fcdfcaf113', 114:'fcdfcaf114', 115:'fcdfcaf115', 
    116:'fcdfcaf116', 117:'fcdfcaf117', 118:'fcdfcaf118', 119:'fcdfcaf119', 
    120:'fcdfcaf120', 121:'fcdfcaf121', 122:'fcdfcaf122', 123:'fcdfcaf123', 
    124:'fcdfcaf124', 125:'fcdfcaf125', 126:'fcdfcaf126', 127:'fcdfcaf127', 
    128:'fcdfcaf128', 129:'fcdfcaf129', 130:'fcdfcaf130', 131:'fcdfcaf131', 
    132:'fcdfcaf132', 133:'fcdfcaf133', 134:'fcdfcaf134', 135:'fcdfcaf135', 
    136:'fcdfcaf136', 137:'fcdfcaf137', 138:'fcdfcaf138', 139:'fcdfcaf139', 
    140:'fcdfcaf140', 141:'fcdfcaf141', 142:'fcdfcaf142', 143:'fcdfcaf143', 
    144:'fcdfcaf144', 145:'fcdfcaf145', 146:'fcdfcaf146', 147:'fcdfcaf147', 
    148:'fcdfcaf148', 149:'fcdfcaf149', 150:'fcdfcaf150', 151:'fcdfcaf151', 
    152:'fcdfcaf152', 153:'fcdfcaf153', 154:'fcdfcaf154', 155:'fcdfcaf155', 
    156:'fcdfcaf156', 157:'fcdfcaf157', 158:'fcdfcaf158', 159:'fcdfcaf159', 
    160:'fcdfcaf160', 161:'fcdfcaf161', 162:'fcdfcaf162', 163:'fcdfcaf163', 
    164:'fcdfcaf164', 165:'fcdfcaf165', 166:'fcdfcaf166', 167:'fcdfcaf167', 
    168:'fcdfcaf168', 169:'fcdfcaf169', 170:'fcdfcaf170', 171:'fcdfcaf171', 
    172:'fcdfcaf172', 173:'fcdfcaf173', 174:'fcdfcaf174', 175:'fcdfcaf175', 
    176:'fcdfcaf176', 177:'fcdfcaf177', 178:'fcdfcaf178', 179:'fcdfcaf179', 
    180:'fcdfcaf180', 181:'fcdfcaf181', 182:'fcdfcaf182', 183:'fcdfcaf183', 
    184:'fcdfcaf184', 185:'fcdfcaf185', 186:'fcdfcaf186', 187:'fcdfcaf187', 
    188:'fcdfcaf188', 189:'fcdfcaf189', 190:'fcdfcaf190', 191:'fcdfcaf191', 
    192:'fcdfcaf192', 193:'fcdfcaf193', 194:'fcdfcaf194', 195:'fcdfcaf195', 
    196:'fcdfcaf196', 197:'fcdfcaf197', 198:'fcdfcaf198', 199:'fcdfcaf199',
    200:'fcdfcaf200', 201:'fcdfcaf201', 202:'fcdfcaf202', 203:'fcdfcaf203',
    204:'fcdfcaf204', 205:'fcdfcaf205', 206:'fcdfcaf206', 207:'fcdfcaf207',
    208:'fcdfcaf208', 209:'fcdfcaf209', 210:'fcdfcaf210', 211:'fcdfcaf211',
    212:'fcdfcaf212', 213:'fcdfcaf213', 214:'fcdfcaf214', 215:'fcdfcaf215',
    216:'fcdfcaf216', 217:'fcdfcaf217', 218:'fcdfcaf218', 219:'fcdfcaf219',
    220:'fcdfcaf220', 221:'fcdfcaf221', 222:'fcdfcaf222', 223:'fcdfcaf223',
    224:'fcdfcaf224', 225:'fcdfcaf225', 226:'fcdfcaf226', 227:'fcdfcaf227',
    228:'fcdfcaf228', 229:'fcdfcaf229', 230:'fcdfcaf230', 231:'fcdfcaf231',
    232:'fcdfcaf232', 233:'fcdfcaf233', 234:'fcdfcaf234', 235:'fcdfcaf235',
    236:'fcdfcaf236', 237:'fcdfcaf237', 238:'fcdfcaf238', 239:'fcdfcaf239',
    240:'fcdfcaf240', 241:'fcdfcaf241', 242:'fcdfcaf242', 243:'fcdfcaf243',
    244:'fcdfcaf244', 245:'fcdfcaf245', 246:'fcdfcaf246', 247:'fcdfcaf247',
    248:'fcdfcaf248', 249:'fcdfcaf249', 250:'fcdfcaf250', 251:'fcdfcaf251',
    252:'fcdfcaf252', 253:'fcdfcaf253', 254:'fcdfcaf254', 255:'fcdfcaf255',
    256:'fcdfcaf256', 257:'fcdfcaf257', 258:'fcdfcaf258', 259:'fcdfcaf259',
    260:'fcdfcaf260', 261:'fcdfcaf261', 262:'fcdfcaf262', 263:'fcdfcaf263',
    264:'fcdfcaf264', 265:'fcdfcaf265', 266:'fcdfcaf266', 267:'fcdfcaf267',
    268:'fcdfcaf268', 269:'fcdfcaf269', 270:'fcdfcaf270', 271:'fcdfcaf271',
    272:'fcdfcaf272', 273:'fcdfcaf273', 274:'fcdfcaf274', 275:'fcdfcaf275',
    276:'fcdfcaf276', 277:'fcdfcaf277', 278:'fcdfcaf278', 279:'fcdfcaf279',
    280:'fcdfcaf280', 281:'fcdfcaf281', 282:'fcdfcaf282', 283:'fcdfcaf283',
    284:'fcdfcaf284', 285:'fcdfcaf285', 286:'fcdfcaf286', 287:'fcdfcaf287',
    288:'fcdfcaf288', 289:'fcdfcaf289', 290:'fcdfcaf290', 291:'fcdfcaf291',
    292:'fcdfcaf292', 293:'fcdfcaf293', 294:'fcdfcaf294', 295:'fcdfcaf295',
    296:'fcdfcaf296', 297:'fcdfcaf297', 298:'fcdfcaf298', 299:'fcdfcaf299',
    300:'fcdfcaf300', 301:'fcdfcaf301', 302:'fcdfcaf302', 303:'fcdfcaf303',
    304:'fcdfcaf304', 305:'fcdfcaf305'
      }


stage1_worker_nodes = {
     1:'fcdfcaf001',  2:'fcdfcaf002',  3:'fcdfcaf003',  4:'fcdfcaf004',
     5:'fcdfcaf005',  6:'fcdfcaf006',  7:'fcdfcaf007',  8:'fcdfcaf008',
     9:'fcdfcaf009', 10:'fcdfcaf010', 11:'fcdfcaf011', 12:'fcdfcaf012',
    13:'fcdfcaf013', 14:'fcdfcaf014', 15:'fcdfcaf015', 16:'fcdfcaf016',
    17:'fcdfcaf017', 18:'fcdfcaf018', 19:'fcdfcaf019', 20:'fcdfcaf020',
    21:'fcdfcaf021', 22:'fcdfcaf022', 23:'fcdfcaf023', 24:'fcdfcaf024',
    25:'fcdfcaf025', 26:'fcdfcaf026', 27:'fcdfcaf027', 28:'fcdfcaf028',
    29:'fcdfcaf029', 30:'fcdfcaf030', 31:'fcdfcaf031', 32:'fcdfcaf032',
    33:'fcdfcaf033', 34:'fcdfcaf034', 35:'fcdfcaf035', 36:'fcdfcaf036',
    37:'fcdfcaf037', 38:'fcdfcaf038', 39:'fcdfcaf039', 40:'fcdfcaf040',
    41:'fcdfcaf041', 42:'fcdfcaf042', 43:'fcdfcaf043', 44:'fcdfcaf044',
    45:'fcdfcaf045', 46:'fcdfcaf046', 47:'fcdfcaf047', 48:'fcdfcaf048',
    49:'fcdfcaf049', 50:'fcdfcaf050', 51:'fcdfcaf051', 52:'fcdfcaf052',
    53:'fcdfcaf053', 54:'', 55:'', 56:'',
    57:'fcdfcaf057', 58:'fcdfcaf058', 59:'fcdfcaf059', 60:'fcdfcaf060',
    61:'fcdfcaf061', 62:'fcdfcaf062', 63:'fcdfcaf063', 64:'fcdfcaf064',
    65:'fcdfcaf065', 66:'fcdfcaf066', 67:'fcdfcaf067'
    }

stage2_worker_nodes = {
      1:'fcdfcaf068',   2:'fcdfcaf069',   3:'fcdfcaf070',   4:'fcdfcaf071', 
      5:'fcdfcaf072',   6:'fcdfcaf073',   7:'fcdfcaf074',   8:'fcdfcaf075', 
      9:'fcdfcaf076',  10:'fcdfcaf077',  11:'fcdfcaf078',  12:'fcdfcaf079', 
     13:'fcdfcaf080',  14:'fcdfcaf081',  15:'fcdfcaf082',  16:'fcdfcaf083', 
     17:'fcdfcaf084',  18:'fcdfcaf085',  19:'fcdfcaf086',  20:'fcdfcaf087', 
     21:'fcdfcaf088',  22:'fcdfcaf089',  23:'fcdfcaf090',  24:'fcdfcaf091', 
     25:'fcdfcaf092',  26:'fcdfcaf093',  27:'fcdfcaf094',  28:'fcdfcaf095', 
     29:'fcdfcaf096',  30:'fcdfcaf097',  31:'fcdfcaf098',  32:'fcdfcaf099', 
     33:'fcdfcaf100',  34:'fcdfcaf101',  35:'fcdfcaf102',  36:'fcdfcaf103', 
     37:'fcdfcaf104',  38:'fcdfcaf105',  39:'fcdfcaf106',  40:'fcdfcaf107', 
     41:'fcdfcaf108',  42:'fcdfcaf109',  43:'fcdfcaf110',  44:'fcdfcaf111', 
     45:'fcdfcaf112',  46:'fcdfcaf113',  47:'fcdfcaf114',  48:'fcdfcaf115', 
     49:'fcdfcaf116',  50:'fcdfcaf117',  51:'fcdfcaf118',  52:'fcdfcaf119', 
     53:'fcdfcaf120',  54:'fcdfcaf121',  55:'fcdfcaf122',  56:'fcdfcaf123', 
     57:'fcdfcaf124',  58:'fcdfcaf125',  59:'fcdfcaf126',  60:'fcdfcaf127', 
     61:'fcdfcaf128',  62:'fcdfcaf129',  63:'fcdfcaf130',  64:'fcdfcaf131', 
     65:'fcdfcaf132',  66:'fcdfcaf133',  67:'fcdfcaf134',  68:'fcdfcaf135', 
     69:'fcdfcaf136',  70:'fcdfcaf137',  71:'fcdfcaf138',  72:'fcdfcaf139', 
     73:'fcdfcaf140',  74:'fcdfcaf141',  75:'fcdfcaf142',  76:'fcdfcaf143', 
     77:'fcdfcaf144',  78:'fcdfcaf145',  79:'fcdfcaf146',  80:'fcdfcaf147', 
     81:'fcdfcaf148',  82:'fcdfcaf149',  83:'fcdfcaf150',  84:'fcdfcaf151', 
     85:'fcdfcaf152',  86:'fcdfcaf153',  87:'fcdfcaf154',  88:'fcdfcaf155', 
     89:'fcdfcaf156',  90:'fcdfcaf157',  91:'fcdfcaf158',  92:'fcdfcaf159', 
     93:'fcdfcaf160',  94:'fcdfcaf161',  95:'fcdfcaf162',  96:'fcdfcaf163', 
     97:'fcdfcaf164',  98:'fcdfcaf165',  99:'fcdfcaf166', 100:'fcdfcaf167', 
    101:'fcdfcaf168', 102:'fcdfcaf169', 103:'fcdfcaf170', 104:'fcdfcaf171', 
    105:'fcdfcaf172', 106:'fcdfcaf173', 107:'fcdfcaf174', 108:'fcdfcaf175', 
    109:'fcdfcaf176', 110:'fcdfcaf177', 111:'fcdfcaf178', 112:'fcdfcaf179', 
    113:'fcdfcaf180', 114:'fcdfcaf181', 115:'fcdfcaf182', 116:'fcdfcaf183', 
    117:'fcdfcaf184', 118:'fcdfcaf185', 119:'fcdfcaf186', 120:'fcdfcaf187', 
    121:'fcdfcaf188', 122:'fcdfcaf189', 123:'fcdfcaf190', 124:'fcdfcaf191', 
    125:'fcdfcaf192', 126:'fcdfcaf193', 127:'fcdfcaf194', 128:'fcdfcaf195', 
    129:'fcdfcaf196', 130:'fcdfcaf197', 131:'fcdfcaf198', 132:'fcdfcaf199',
    133:'fcdfcaf200', 134:'fcdfcaf201', 135:'fcdfcaf202', 136:'fcdfcaf203',
    137:'fcdfcaf204', 138:'fcdfcaf205', 139:'fcdfcaf206', 130:'fcdfcaf207',
    141:'fcdfcaf208', 142:'fcdfcaf209', 143:'fcdfcaf210', 144:'fcdfcaf211',
    145:'fcdfcaf212', 146:'fcdfcaf213', 147:'fcdfcaf214', 148:'fcdfcaf215',
    149:'fcdfcaf216', 150:'fcdfcaf217', 151:'fcdfcaf218', 152:'fcdfcaf219',
    153:'fcdfcaf220', 154:'fcdfcaf221', 155:'fcdfcaf222', 156:'fcdfcaf223',
    157:'fcdfcaf224', 158:'fcdfcaf225', 159:'fcdfcaf226', 160:'fcdfcaf227',
    161:'fcdfcaf228', 162:'fcdfcaf229', 163:'fcdfcaf230', 164:'fcdfcaf231',
    165:'fcdfcaf232', 166:'fcdfcaf233', 167:'fcdfcaf234', 168:'fcdfcaf235',
    169:'fcdfcaf236', 170:'fcdfcaf237', 171:'fcdfcaf238', 172:'fcdfcaf239',
    173:'fcdfcaf240', 174:'fcdfcaf241', 175:'fcdfcaf242', 176:'fcdfcaf243',
    177:'fcdfcaf244', 178:'fcdfcaf245', 179:'fcdfcaf246', 180:'fcdfcaf247',
    181:'fcdfcaf248', 182:'fcdfcaf249', 183:'fcdfcaf250', 184:'fcdfcaf251',
    185:'fcdfcaf252', 186:'fcdfcaf253', 187:'fcdfcaf254', 188:'fcdfcaf255',
    189:'fcdfcaf256', 190:'fcdfcaf257', 191:'fcdfcaf258', 192:'fcdfcaf259',
    193:'fcdfcaf260', 194:'fcdfcaf261', 195:'fcdfcaf262', 196:'fcdfcaf263',
    197:'fcdfcaf264', 198:'fcdfcaf265', 199:'fcdfcaf266', 200:'fcdfcaf267',
    201:'fcdfcaf268', 202:'fcdfcaf269', 203:'fcdfcaf270', 204:'fcdfcaf271',
    205:'fcdfcaf272', 206:'fcdfcaf273', 207:'fcdfcaf274', 208:'fcdfcaf275',
    209:'fcdfcaf276', 210:'fcdfcaf277', 211:'fcdfcaf278', 212:'fcdfcaf279',
    213:'fcdfcaf280', 214:'fcdfcaf281', 215:'fcdfcaf282', 216:'fcdfcaf283',
    217:'fcdfcaf284', 218:'fcdfcaf285', 219:'fcdfcaf286', 220:'fcdfcaf287',
    221:'fcdfcaf288', 222:'fcdfcaf289', 223:'fcdfcaf290', 224:'fcdfcaf291',
    225:'fcdfcaf292', 226:'fcdfcaf293', 227:'fcdfcaf294', 228:'fcdfcaf295',
    229:'fcdfcaf296', 230:'fcdfcaf297', 231:'fcdfcaf298', 232:'fcdfcaf299',
    233:'fcdfcaf300', 234:'fcdfcaf301', 235:'fcdfcaf302', 236:'fcdfcaf303',
    237:'fcdfcaf304', 238:'fcdfcaf305'
      }


stats = {1:'load_average', 2:'cpu', 3:'netxfer', 4:'memory'}

statLabels = {'load_average':'Load averages',
              'cpu':'CPU usage',
              'netxfer':'Network throughput',
              'memory':'Memory usage'}
ds = {
    'load_average':['la1', 'la5', 'la15'],
    'cpu':['user_cpu0', 'nice_cpu0', 'system_cpu0'],
    'netxfer':['rxd', 'txd'],
    'memory':['mem_ratio', 'swap']
      }
cdef = {
    'la1':'',
    'la5':'',
    'la15':'',
    'user_cpu0':'',
    'nice_cpu0':'',
    'system_cpu0':'',
    'rxd':'',
    'txd':'',
    'mem_ratio':' CDEF:cdef_mymem_ratio=mymem_ratio,100,* ',
    'swap':' CDEF:cdef_myswap=myswap,100,* '
    }
statSpecRRDStr = {
    'load_average':' --vertical-label="load avg" ',
    'cpu':' --upper-limit=100 --lower-limit=0.01 --rigid --vertical-label="% used" ',
    'netxfer':' --vertical-label="bytes/sec" ',
    'memory':' --upper-limit=100 --lower-limit=0.01 --rigid --vertical-label="% used" '
    }
statSpecTitleStr = {
    'load_average':' --title="Load Average for "',
    'cpu':' --title="CPU usage for "',
    'netxfer':' --title="Network throughput for "',
    'memory':' --title="Memory usage for "'
    }
dsSpecLegendStr = {
    'la1':'"Averaged over 1 min"',
    'la5':'"Averaged over 5 min"',
    'la15':'"Averaged over 15 min"',
    'user_cpu0':'"User"',
    'nice_cpu0':'"Nice"',
    'system_cpu0':'"System"',
    'rxd':'"Received"',
    'txd':'"Transmitted"',
    'mem_ratio':'"Real"',
    'swap':'"Swap"'
    }
graphdir = '/var/www/cgi-bin'
rrdtool_path = '/home/cafmon/bin'
rrd_path = '/home/cafmon/cafmon/RRD/'
genericStr = ''
MyURL = 'http://cdfcaf.fnal.gov/cgi-bin/caf/admin/graphs.py'
Style = """
<STYLE TYPE="text/css">
<!-- /* Hide from browsers that do not understand CSS */
BODY {
  font-family : Tahoma;
  color : black;
}
TD {
  font-family : Tahoma, Verdana, Arial;
  font-size: 11px;
  color : black;
}
TH {
  font-family : Verdana, Tahoma;
  font-size: 10px;
  font-weight: bold;
  color : black;
}
-->
</STYLE></head>
"""

# Head of HTML page
def htmlHead(title='CDF CAF Admin Monitoring Graphs', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print
    print '  <p><table border=0>'
    print '    <tr valign="center">'
    print '    <td width="100"  valign="center" halign="center">'
    print '      <a href="http://cdfcaf.fnal.gov/">'
    print '      <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '    <td valign="center" halign="center"><h1><font size=+10>'
    print '      CDF Central Analysis Facility<br></font></h1>'
    print '      <center><h1><font size=+5 color="#AA5500">Admin Monitoring Page</font><h1></center><br></td>'
    print '    </tr>'
    print '  </table>'
    print    
    print '  <hr>'
    print

# Tail of HTML page
def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

# Body of HTML page
def htmlBody():

    # Set default options
    logplot = 0
    period = 'day'

    # Store parameter strings pass to CGI script
    queue = cgi.FieldStorage()

    # Loop over CGI parameters and extract information
    nodeNames = []
    statNames = []
    allstat, allutil, allsrv, allwrk, dCachesrv, static1srv, static2srv, \
             Stage1wrk, Stage2wrk = (0, 0, 0, 0, 0, 0, 0, 0, 0)
    cgi_nodeStr = ''
    cgi_statStr = ''
    for name in queue.keys():
        if name == 'period':
            period = queue[name].value
        elif(string.find(name,"node") > -1):
            if queue[name].value == "all":
                if name == "nodeutil":
                    allutil = 1
                if name == "nodesrv":
                    allsrv = 1
                if name == "node":
                    allwrk = 1
            elif (queue[name].value == "Stage1" and name == "node"):
                Stage1wrk = 1
            elif (queue[name].value == "Stage2" and name == "node"):
                Stage2wrk = 1
            elif (queue[name].value == "dCache" and name == "nodesrv"):
                dCachesrv = 1
            elif (queue[name].value == "static1" and name == "nodesrv"):
                statics1rv = 1
            elif (queue[name].value == "static2" and name == "nodesrv"):
                static2srv = 1
            else:
                nodeNames.append(queue[name].value)
            cgi_nodeStr = cgi_nodeStr + name+'='+queue[name].value+'&'
        elif(string.find(name,"stat") > -1):
            if queue[name].value == "all":
                allstat = 1
            statNames.append(queue[name].value)
            cgi_statStr = cgi_statStr + name+'='+queue[name].value+'&'
        elif name == 'optlog':
            logplot = 1
    nodeNames.sort()

    if allstat:
        statNames = stats.values()
        nodeNames.reverse()
    if allutil:
        nodeNames = nodeNames + utility_nodes.values()
        nodeNames.reverse()
    if allsrv:
        nodeNames = nodeNames + servers.values()
        nodeNames.reverse()
    if allwrk:
        nodeNames = nodeNames + worker_nodes.values()
        nodeNames.reverse()
    if Stage1wrk:
        nodeNames = nodeNames + stage1_worker_nodes.values()
        nodeNames.reverse()
    if Stage2wrk:
        nodeNames = nodeNames + stage2_worker_nodes.values()
        nodeNames.reverse()
    if dCachesrv:
        nodeNames = nodeNames + dCache_servers.values()
        nodeNames.reverse()
    if static1srv:
        nodeNames = nodeNames + stage1_static_servers.values()
        nodeNames.reverse()
    if static2srv:
        nodeNames = nodeNames + stage2_static_servers.values()
        nodeNames.reverse()

    # Set up border around graphs
    print '<table width="100%" cellpadding="1" bgcolor="#103D3B" border=0 cellspacing=5>'
    print '  <tr><td>'
    print '  <table cellpadding=3 cellspacing=3><tr>'
    print '    <td bgcolor="#80DDCB">Period:</td>'
    for x in ['day','3days','week','2weeks','month','3months','year']:
        print '    <td bgcolor="#80DDCB">',
        if x == period:
            print '<b>%s</b>' % period,
        else:
            print '<a href="%s?%s%s&period=%s">%s</a>' %\
                  (MyURL, cgi_nodeStr, cgi_statStr, x, x),
        print '</td>'
    print '  </tr></table>'
    print '  </td></tr>'
    print '</table>'
    print
    print '<table  width="100%" border=0 bgcolor="#103D3B" cellspacing=5 cellpadding="1">'
    print '  <tr valign="top">'
    print '    <td><table  width="100%" bgcolor="#103D3B" border=0 cellspacing=5 cellpadding="1">'
    print '      <tr><td bgcolor="#80DDCB"><a href="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/cafmon">Top Level</a></td></tr>'
    print '    </table>'

    # Assign starting period for graphs
    start = rrd_periods[period]

    # Display CAF usage graph
    print '    <td bgcolor="#80DDCB"><table width="100%" border=0>'
    showFarmUsage = 1
    if showFarmUsage:
        graph = '/caf/admin/graphs/farmUsage'+'_'+period+'.gif'
        farmUsageStr = ' --title="CAF worker CPU utilization" --vertical-label="Number of CPUs" --upper-limit=135 --rigid -w  400 -h 200'
        color_idx = 0
        for procType in proc_types:
            color_idx = color_idx + 1
            colorStr = '#'+colors[color_idx]
            dsProcType = ds_proc_types[procType]
            farmUsageStr = farmUsageStr+' DEF:my'+procType+\
                    'Usage=/home/cafmon/fbsmon/db/queues/total.rrd:'+\
                    dsProcType+':AVERAGE LINE2:my'+procType+'Usage'+colorStr+\
                    ':'+procType
        str = rrdtool_path+'/rrdtool graph '+graphdir+graph+\
            ' -c BACK#DDDDDD -c CANVAS#FFFFFF -c MGRID#000000 -c FONT#000000'+\
            ' --start -'+start+farmUsageStr
        commands.getoutput(str)
        print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph=farmUsage'+'_'+period+'.gif"></tr></td>'
        print '<tr><td><hr></tr></td>'


    # Print averages for all requested nodes
    print '<tr><td><a NAME="avg"><h2>Averages</h2></a></tr></td>'

    for statName in statNames:
        graph = '/caf/admin/graphs/avg_'+statName+'_'+period+\
                '.gif'
        statSpecStr = statSpecRRDStr[statName]
        titleStr = statSpecTitleStr[statName]
        dsList = ds[statName]
        dsStr = ''
        cdefStr = ''
        color_idx = 0
        for dsName in dsList:
            color_idx = color_idx + 1
            colorStr = '#'+colors[color_idx]
            legendStr = dsSpecLegendStr[dsName]
            idx = 0
            for nodeName in nodeNames:
                sidx = "_%d" % idx
                dsStr = dsStr + 'DEF:my'+dsName+sidx+'='+rrd_path+'/'+\
                        nodeName+'.rrd:'+dsName+':AVERAGE '
                idx = idx + 1

            cdefStr = cdefStr + 'CDEF:'+dsName+'_sum1=0,my'+dsName+'_0,+ '
            for n in range(2, (len(nodeNames)+1)):
                sn = "%d" % n
                snm1 = "%d" % (n-1)
                cdefStr = cdefStr + 'CDEF:'+dsName+'_sum'+sn+'='+\
                          dsName+'_sum'+snm1+',my'+dsName+'_'+snm1+',+ '
            snumnodes = "%d" % len(nodeNames)

            if len(cdef[dsName]):
                cdefStr = cdefStr + 'CDEF:'+dsName+'_avg='+dsName+'_sum'+\
                          snumnodes+','+snumnodes+',/ '+\
                          'CDEF:cdef_'+dsName+'_avg='+dsName+'_avg,100,* '+\
                          'LINE2:cdef_'+dsName+'_avg' +\
                          colorStr+':'+legendStr+' '
            else:
                cdefStr = cdefStr + 'CDEF:'+dsName+'_avg='+dsName+'_sum'+\
                          snumnodes+','+snumnodes+',/ LINE2:'+dsName+'_avg' +\
                          colorStr+':'+legendStr+' '
                
        str = rrdtool_path+'/rrdtool graph '+graphdir+graph+ ' --start -'+\
              start+titleStr+'all '+genericStr+statSpecStr+dsStr+cdefStr
        
#        print str
        commands.getoutput(str)
        print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph=avg_'+statName+'_'+period+'.gif"></tr></td>'
    print '<tr><td><hr></tr></td>'


# Show aggregate for network bandwidth

    print '<tr><td><a NAME="Aggregate"><h2>Aggregate</h2></a></tr></td>'
    for statName in statNames:
        if statName == 'netxfer':
            graph = '/caf/admin/graphs/agg_'+statName+'_'+period+\
                    '.gif'
            statSpecStr = statSpecRRDStr[statName]
            titleStr = statSpecTitleStr[statName]
            dsList = ds[statName]
            dsStr = ''
            cdefStr = ''
            color_idx = 0
            for dsName in dsList:
                color_idx = color_idx + 1
                colorStr = '#'+colors[color_idx]
                legendStr = dsSpecLegendStr[dsName]
                idx = 0
                for nodeName in nodeNames:
                    sidx = "%d" % idx
                    dsStr = dsStr + 'DEF:my'+dsName+sidx+'='+rrd_path+'/'+\
                            nodeName+'.rrd:'+dsName+':AVERAGE '
                    idx = idx + 1

                cdefStr = cdefStr + 'CDEF:'+dsName+'_sum1=0,my'+dsName+'0,+ '
                for n in range(2, (len(nodeNames)+1)):
                    sn = "%d" % n
                    snm1 = "%d" % (n-1)
                    cdefStr = cdefStr + 'CDEF:'+dsName+'_sum'+sn+'='+\
                              dsName+'_sum'+snm1+',my'+dsName+snm1+',+ '
                snumnodes = "%d" % len(nodeNames)

                cdefStr = cdefStr + 'LINE2:'+dsName+'_sum'+snumnodes+\
                          colorStr+':'+legendStr+' '
                
            str = rrdtool_path+'/rrdtool graph '+graphdir+graph+ ' --start -'+\
                  start+titleStr+'all '+genericStr+statSpecStr+dsStr+cdefStr
        
#        print str
            commands.getoutput(str)
            print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph=agg_'+statName+'_'+period+'.gif"></tr></td>'
            print '<tr><td><hr></tr></td>'

    print '<tr><td>Go to statistic:<br>'
    for x in statLabels.values():
        print '<a HREF="#'+x+'">'+x+'</a>'
    print '<br><br></tr></td>'

    # Loop over all requested nodes and statistics to graph
    for statName in statNames:
        print '<tr><td><a NAME="'+statLabels[statName]+'"><h2>'+statLabels[statName]+'</h2></a></tr></td>'
        for nodeName in nodeNames:
            graph = '/caf/admin/graphs/'+nodeName+'_'+statName+'_'+period+\
                    '.gif'
            statSpecStr = statSpecRRDStr[statName]
            if logplot:
                statSpecStr = statSpecStr+'--logarithmic '
            titleStr = statSpecTitleStr[statName]
            dsList = ds[statName]
            dsStr = ''
            color_idx = 0
            for dsName in dsList:
                color_idx = color_idx + 1
                colorStr = '#'+colors[color_idx]
                legendStr = dsSpecLegendStr[dsName]
                cdefStr = cdef[dsName]
                if len(cdefStr):
                    dsStr = dsStr + 'DEF:my'+dsName+'='+rrd_path+'/'+nodeName+\
                            '.rrd:'+dsName+':AVERAGE '+cdefStr+\
                            'LINE2:cdef_my'+dsName+colorStr+':'+legendStr+' '
                else:
                    dsStr = dsStr + 'DEF:my'+dsName+'='+rrd_path+'/'+nodeName+\
                            '.rrd:'+dsName+':AVERAGE LINE2:my'+dsName+\
                            colorStr+':'+legendStr+' '
                
            str = rrdtool_path+'/rrdtool graph '+graphdir+graph+ ' --start -'+\
                  start+titleStr+nodeName+genericStr+statSpecStr+dsStr
#            print str
            commands.getoutput(str)
            print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph='+nodeName+'_'+statName+'_'+period+'.gif"></tr></td>'
        print '<tr><td><hr></tr></td>'

    print '    </td></table>'
    print '  </td></tr>'
    print '</table>'

# Main program
if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()

