#!/usr/bin/python
import cgi
import commands
import os
import string
from nodes import *

stats = {
    1:['load_average', 'Load averages'],
    2:['cpu','CPU usage'],
    3:['netxfer','Network throughput'],
    4:['memory','Memory usage']
    }

ncols = 4

Style = """
<STYLE TYPE="text/css">
  h2 { margin-left: +0%; color: #000000}
  h3 { margin-left: +0%; color: #228800}
  p { color: #000000 }
  blockquote { margin-left: +2%; color: #FF33333 }
  pre { color: #990033 }
</STYLE>
"""

def htmlHead(title='CDF CAF Admin Monitoring page', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print '<p><table border=0>'
    print '  <tr valign="center">'
    print '  <td width="100"  valign="center" halign="center">'
    print '    <a href="http://cdfcaf.fnal.gov/">'
    print '    <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '  <td valign="center" halign="center"><h1><font size=+10>'
    print '    CDF Central Analysis Facility<br></font></h1>'
    print '    <center><h1><font size=+5 color="#AA5500">Admin Monitoring Page</font><h1></center><br></td>'
    print '  </tr>'
    print '</table>'
    print    
    print '<hr>'
    print    

def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

def htmlBody():
    print '<body bgcolor="white">'
    print '<form method="get" action="/cgi-bin/caf/admin/graphs.py">'
    print    

    # Statistics
    print '<h2>Check the statistics to view</h2>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="stat" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    for i in range(len(stats)):
        statsList = stats[i+1]
        print '<td width="25%" valign="top"><font color="#990033">'
        print '  <input type="checkbox" name="stat%s" value="%s"> %s</a>' %\
              (i, statsList[0], statsList[1])
        
    print '<br>'
    print '</font></td>'
    print '</tr>'
    print '</table><p>'
    print '<hr>'
    print    
    print '<h2>Check the nodes to view above statistics on:</h2>'
    print    

    # Utility nodes
    print '<h3>Utility nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all button
    print '<td width="25%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodeutil" value="all">ALL</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 4
    irow = 0
    if len(utility_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(utility_nodes) / ncols) + 1
    for node in utility_nodes:
        i = utility_nodes.index(node)
        print '  <input type="checkbox" name="nodeutil%s" value="%s"> %s</a><br>' \
              % (i, node, node)
        irow = irow+1
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Servers
    print '<h3>Servers</h3>'
    print '<table border=0 width=515><tr>'

    # all, static and dCache buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="nodesrv" value="all">ALL </a>'
    print '  <input type="checkbox" name="nodesrv" value="dCache">dCache </a>'
    print '  <input type="checkbox" name="nodesrv" value="static1">Stage 1 static </a>'
    print '  <input type="checkbox" name="nodesrv" value="static2">Stage 2 static </a>'
    print '  <input type="checkbox" name="nodesrv" value="teststand">dCache test stand </a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="50%" valign="top"><font color="#990033">'
    ncols = 1
    irow = 0
    if len(servers) == ncols:
        nrows = 1
    else:
        nrows = int(len(servers) / ncols) + 1
    for node in servers:
        i = servers.index(node)
        if (node_description.has_key(node) and len(node_description[node]) > 0) : 
            description = ' - '+node_description[node]
        else:
            description = ''
        print '  <input type="checkbox" name="nodesrv%s" value="%s"> %s %s</a><br>' \
              % (i, node, node, description)
        irow = irow+1
        if irow == 16:
            print '<hr>'
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0
            
    print '</font></td>'
    print '</tr>'
    print '</table>'
    print    

    # Worker nodes
    print '<h3>Worker nodes</h3>'
    print '<table border=0 width=515><tr>'

    # all, Stage 1, and Stage 2 buttons
    print '<td width="100%" valign="top"><font color="#330099">'
    print '  <input type="checkbox" name="node" value="all">ALL </a>'
    print '  <input type="checkbox" name="node" value="Stage1">Stage 1 </a>'
    print '  <input type="checkbox" name="node" value="Stage2">Stage 2 - all </a>'
    print '  <input type="checkbox" name="node" value="Stage2-static">Stage 2 - static</a>'
    print '</td></tr>'
    print '<tr>'

    print '<td width="25%" valign="top"><font color="#990033">'
    ncols = 1
    if len(worker_nodes) == ncols:
        nrows = 1
    else:
        nrows = int(len(worker_nodes) / ncols) + 1
    irow = 0
    for node in worker_nodes:
        i = worker_nodes.index(node)
        if (node_description.has_key(node) and len(node_description[node]) > 0) : 
            description = ' - '+node_description[node]
        else:
            description = ''
        print '  <input type="checkbox" name="node%s" value="%s"> %s %s</a><br>' \
              % (i, node, node, description)
        irow = irow+1
        if irow == 67:
            print '<hr>'
        if irow == nrows:
            print '</font></td>'
            print '<td width="25%" valign="top"><font color="#990033">'
            irow = 0

    print '</font></td>'
    print '</tr>'
    print '</table>'
    print '<hr>'
    print    
    print '<br>'
    print '<input type="checkbox" name="optlog" value="1"> Log plots?</a>'
    print '</br>'
    print '<hr>'
    print    
    print '<input type="submit" value="Submit">'

    print '</form>'

if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()


