#!/usr/bin/python
import cgi
import commands
import os
import string

# Global definitions
colors = {
    1:"ff0000",2:"0000ff",3:"00ff00",5:"FFFF00",4:"00DDDD",6:"FF00FF",
    7:"af7817",8:"7931df",9:"980517",10:"578693",11:"f76541",12:"f5f3d7",
    13:"e18b6b",14:"7d1b7e",15:"4e9258",16:"b7ad59",17:"3bb9ff", 18:"d4a017",
    19:"f52887",20:"3b9c99" 
    }
rrd_periods = {
    'day':'1d', '3days':'3d', 'week':'1w', '2weeks':'2w', 'month':'1mon',
    '3months':'3mon', 'year':'1y'}

proc_types = ['short', 'medium', 'long', 'total']
ds_proc_types = {
    'short':'NrS',
    'medium':'NrM',
    'long':'NrL',
    'total':'NrT'
    }

utility_nodes = {
    1:'fcdfhead1',
    2:'fcdfmon1',
    3:'fcdfcode1',
    4:'fcdflnx1',
    5:'fcdflnx2',
    6:'fcdflnx3'
    }

servers = {
     1:'fcdfdata001',  2:'fcdfdata002',  3:'fcdfdata003',  4:'fcdfdata004',
     5:'fcdfdata005',  6:'fcdfdata006',  7:'fcdfdata007',  8:'fcdfdata008',
     9:'fcdfdata009', 10:'fcdfdata010', 11:'fcdfdata011', 12:'fcdfdata012',
    13:'fcdfdata013', 14:'fcdfdata014', 15:'fcdfdata015', 16:'fcdfdata016',
    17:'fcdfdata017', 18:'fcdfdata018', 19:'fcdfdata019', 20:'fcdfdata020',
    21:'fcdfdata021', 22:'fcdfdata022', 23:'fcdfdata023', 24:'fcdfdata024',
    25:'fcdfdata025', 26:'fcdfdata026', 27:'fcdfdata027', 28:'fcdfdata028',
    29:'fcdfdata029', 30:'fcdfdata030', 31:'fcdfdata031', 32:'fcdfdata032',
    33:'fcdfdata033', 34:'fcdfdata034', 35:'fcdfdata035', 36:'fcdfdata036',
    37:'fcdfdata037', 38:'fcdfdata038', 39:'fcdfdata039', 40:'fcdfdata040',
    41:'fcdfdata041', 42:'fcdfdata042', 43:'fcdfdata043', 44:'fcdfdata044',
    45:'fcdfdata045', 46:'fcdfdata046', 47:'fcdfdata047', 48:'fcdfdata048',
    49:'fcdfdata049', 50:'fcdfdata050', 51:'fcdfdata051', 52:'fcdfdata052',
    53:'fcdfdata053', 54:'fcdfdata054', 55:'fcdfdata055', 56:'fcdfdata056',
    57:'fcdfdata057', 58:'fcdfdata058', 59:'fcdfdata059', 60:'fcdfdata060',
    61:'fcdfdata061', 62:'fcdfdata062', 63:'fcdfdata063', 64:'fcdfdata064',
    65:'fcdfdata065', 66:'fcdfdata066', 67:'fcdfdata067', 68:'fcdfdata068',
    69:'fcdfdata069', 70:'fcdfdata070', 71:'fcdfdata071', 72:'fcdfdata072',
    73:'fcdfdata073', 74:'fcdfdata074', 75:'fcdfdata075', 76:'fcdfdata076',
    77:'fcdfdata077', 78:'fcdfdata078', 79:'fcdfdata079', 80:'fcdfdata080',
    81:'fcdfdata081', 82:'fcdfdata082', 83:'fcdfdata083', 84:'fcdfdata084',
    85:'fcdfdata085', 86:'fcdfdata086', 87:'fcdfdata087', 88:'fcdfdata088',
    89:'fcdfdata089', 90:'fcdfdata090', 91:'fcdfdata091'
    }

dCache_servers = {
      1:'fcdfdata008',  2:'fcdfdata009',  3:'fcdfdata010',  4:'fcdfdata011',
      5:'fcdfdata017',  6:'fcdfdata018',  7:'fcdfdata019',  8:'fcdfdata020',
      9:'fcdfdata021', 10:'fcdfdata022', 11:'fcdfdata023', 12:'fcdfdata024',
     13:'fcdfdata035', 14:'fcdfdata036', 15:'fcdfdata037', 16:'fcdfdata038',
     17:'fcdfdata039', 18:'fcdfdata040'
    }

static_servers = {
     1:'fcdfdata001',  2:'fcdfdata002',  3:'fcdfdata003',  4:'fcdfdata004',
     5:'fcdfdata005',  6:'fcdfdata006',  7:'fcdfdata015'
    }

worker_nodes = {
     1:'fcdfcaf001',  2:'fcdfcaf002',  3:'fcdfcaf003',  4:'fcdfcaf004',
     5:'fcdfcaf005',  6:'fcdfcaf006',  7:'fcdfcaf007',  8:'fcdfcaf008',
     9:'fcdfcaf009', 10:'fcdfcaf010', 11:'fcdfcaf011', 12:'fcdfcaf012',
    13:'fcdfcaf013', 14:'fcdfcaf014', 15:'fcdfcaf015', 16:'fcdfcaf016',
    17:'fcdfcaf017', 18:'fcdfcaf018', 19:'fcdfcaf019', 20:'fcdfcaf020',
    21:'fcdfcaf021', 22:'fcdfcaf022', 23:'fcdfcaf023', 24:'fcdfcaf024',
    25:'fcdfcaf025', 26:'fcdfcaf026', 27:'fcdfcaf027', 28:'fcdfcaf028',
    29:'fcdfcaf029', 30:'fcdfcaf030', 31:'fcdfcaf031', 32:'fcdfcaf032',
    33:'fcdfcaf033', 34:'fcdfcaf034', 35:'fcdfcaf035', 36:'fcdfcaf036',
    37:'fcdfcaf037', 38:'fcdfcaf038', 39:'fcdfcaf039', 40:'fcdfcaf040',
    41:'fcdfcaf041', 42:'fcdfcaf042', 43:'fcdfcaf043', 44:'fcdfcaf044',
    45:'fcdfcaf045', 46:'fcdfcaf046', 47:'fcdfcaf047', 48:'fcdfcaf048',
    49:'fcdfcaf049', 50:'fcdfcaf050', 51:'fcdfcaf051', 52:'fcdfcaf052',
    53:'fcdfcaf053', 54:'fcdfcaf054', 55:'fcdfcaf055', 56:'fcdfcaf056',
    57:'fcdfcaf057', 58:'fcdfcaf058', 59:'fcdfcaf059', 60:'fcdfcaf060',
    61:'fcdfcaf061', 62:'fcdfcaf062', 63:'fcdfcaf063', 64:'fcdfcaf064',
    65:'fcdfcaf065', 66:'fcdfcaf066', 67:'fcdfcaf067'
    }

stats = {1:'load_average', 2:'cpu', 3:'netxfer', 4:'memory'}

statLabels = {'load_average':'Load averages',
              'cpu':'CPU usage',
              'netxfer':'Network throughput',
              'memory':'Memory usage'}
ds = {
    'load_average':['la1', 'la5', 'la15'],
    'cpu':['user_cpu0', 'nice_cpu0', 'system_cpu0'],
    'netxfer':['rxd', 'txd'],
    'memory':['mem_ratio', 'swap']
      }
cdef = {
    'la1':'',
    'la5':'',
    'la15':'',
    'user_cpu0':'',
    'nice_cpu0':'',
    'system_cpu0':'',
    'rxd':'',
    'txd':'',
    'mem_ratio':' CDEF:cdef_mymem_ratio=mymem_ratio,100,* ',
    'swap':' CDEF:cdef_myswap=myswap,100,* '
    }
statSpecRRDStr = {
    'load_average':' --vertical-label="load avg" ',
    'cpu':' --upper-limit=100 --lower-limit=0.01 --rigid --vertical-label="% used" ',
    'netxfer':' --vertical-label="bytes/sec" ',
    'memory':' --upper-limit=100 --lower-limit=0.01 --rigid --vertical-label="% used" '
    }
statSpecTitleStr = {
    'load_average':' --title="Load Average for "',
    'cpu':' --title="CPU usage for "',
    'netxfer':' --title="Network throughput for "',
    'memory':' --title="Memory usage for "'
    }
dsSpecLegendStr = {
    'la1':'"Averaged over 1 min"',
    'la5':'"Averaged over 5 min"',
    'la15':'"Averaged over 15 min"',
    'user_cpu0':'"User"',
    'nice_cpu0':'"Nice"',
    'system_cpu0':'"System"',
    'rxd':'"Received"',
    'txd':'"Transmitted"',
    'mem_ratio':'"Real"',
    'swap':'"Swap"'
    }
graphdir = '/var/www/cgi-bin'
rrdtool_path = '/home/cafmon/bin'
rrd_path = '/home/cafmon/cafmon/RRD/'
genericStr = ''
MyURL = 'http://cdfcaf.fnal.gov/cgi-bin/caf/admin/graphs.py'
Style = """
<STYLE TYPE="text/css">
<!-- /* Hide from browsers that do not understand CSS */
BODY {
  font-family : Tahoma;
  color : black;
}
TD {
  font-family : Tahoma, Verdana, Arial;
  font-size: 11px;
  color : black;
}
TH {
  font-family : Verdana, Tahoma;
  font-size: 10px;
  font-weight: bold;
  color : black;
}
-->
</STYLE></head>
"""

# Head of HTML page
def htmlHead(title='CDF CAF Admin Monitoring Graphs', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print
    print '  <p><table border=0>'
    print '    <tr valign="center">'
    print '    <td width="100"  valign="center" halign="center">'
    print '      <a href="http://cdfcaf.fnal.gov/">'
    print '      <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '    <td valign="center" halign="center"><h1><font size=+10>'
    print '      CDF Central Analysis Facility<br></font></h1>'
    print '      <center><h1><font size=+5 color="#AA5500">Admin Monitoring Page</font><h1></center><br></td>'
    print '    </tr>'
    print '  </table>'
    print    
    print '  <hr>'
    print

# Tail of HTML page
def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

# Body of HTML page
def htmlBody():

    # Set default options
    logplot = 0
    period = 'day'

    # Store parameter strings pass to CGI script
    queue = cgi.FieldStorage()

    # Loop over CGI parameters and extract information
    nodeNames = []
    statNames = []
    allstat, allutil, allsrv, allwrk, dCachesrv, staticsrv = (0, 0, 0, 0, 0, 0)
    cgi_nodeStr = ''
    cgi_statStr = ''
    for name in queue.keys():
        if name == 'period':
            period = queue[name].value
        elif(string.find(name,"node") > -1):
            if queue[name].value == "all":
                if name == "nodeutil":
                    allutil = 1
                if name == "nodesrv":
                    allsrv = 1
                if name == "node":
                    allwrk = 1
            elif (queue[name].value == "dCache" and name == "nodesrv"):
                dCachesrv = 1
            elif (queue[name].value == "static" and name == "nodesrv"):
                staticsrv = 1
            else:
                nodeNames.append(queue[name].value)
            cgi_nodeStr = cgi_nodeStr + name+'='+queue[name].value+'&'
        elif(string.find(name,"stat") > -1):
            if queue[name].value == "all":
                allstat = 1
            statNames.append(queue[name].value)
            cgi_statStr = cgi_statStr + name+'='+queue[name].value+'&'
        elif name == 'optlog':
            logplot = 1
    nodeNames.sort()

    if allstat:
        statNames = stats.values()
    if allutil:
        nodeNames = nodeNames + utility_nodes.values()
    if allsrv:
        nodeNames = nodeNames + servers.values()
    if allwrk:
        nodeNames = nodeNames + worker_nodes.values()
    if dCachesrv:
        nodeNames = nodeNames + dCache_servers.values()
    if staticsrv:
        nodeNames = nodeNames + static_servers.values()

    # Set up border around graphs
    print '<table width="100%" cellpadding="1" bgcolor="#103D3B" border=0 cellspacing=5>'
    print '  <tr><td>'
    print '  <table cellpadding=3 cellspacing=3><tr>'
    print '    <td bgcolor="#80DDCB">Period:</td>'
    for x in ['day','3days','week','2weeks','month','3months','year']:
        print '    <td bgcolor="#80DDCB">',
        if x == period:
            print '<b>%s</b>' % period,
        else:
            print '<a href="%s?%s%s&period=%s">%s</a>' %\
                  (MyURL, cgi_nodeStr, cgi_statStr, x, x),
        print '</td>'
    print '  </tr></table>'
    print '  </td></tr>'
    print '</table>'
    print
    print '<table  width="100%" border=0 bgcolor="#103D3B" cellspacing=5 cellpadding="1">'
    print '  <tr valign="top">'
    print '    <td><table  width="100%" bgcolor="#103D3B" border=0 cellspacing=5 cellpadding="1">'
    print '      <tr><td bgcolor="#80DDCB"><a href="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/cafmon">Top Level</a></td></tr>'
    print '    </table>'

    # Assign starting period for graphs
    start = rrd_periods[period]

    # Display CAF usage graph
    print '    <td bgcolor="#80DDCB"><table width="100%" border=0>'
    showFarmUsage = 1
    if showFarmUsage:
        graph = '/caf/admin/graphs/farmUsage'+'_'+period+'.gif'
        farmUsageStr = ' --title="CAF worker CPU utilization" --vertical-label="Number of CPUs" --upper-limit=135 --rigid -w  400 -h 200'
        color_idx = 0
        for procType in proc_types:
            color_idx = color_idx + 1
            colorStr = '#'+colors[color_idx]
            dsProcType = ds_proc_types[procType]
            farmUsageStr = farmUsageStr+' DEF:my'+procType+\
                    'Usage=/home/cafmon/fbsmon/db/queues/total.rrd:'+\
                    dsProcType+':AVERAGE LINE2:my'+procType+'Usage'+colorStr+\
                    ':'+procType
        str = rrdtool_path+'/rrdtool graph '+graphdir+graph+\
            ' -c BACK#DDDDDD -c CANVAS#FFFFFF -c MGRID#000000 -c FONT#000000'+\
            ' --start -'+start+farmUsageStr
        commands.getoutput(str)
        print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph=farmUsage'+'_'+period+'.gif"></tr></td>'
        print '<tr><td><hr></tr></td>'


    # Print averages for all requested nodes
    print '<tr><td><a NAME="avg"><h2>Averages</h2></a></tr></td>'

    for statName in statNames:
        graph = '/caf/admin/graphs/avg_'+statName+'_'+period+\
                '.gif'
        statSpecStr = statSpecRRDStr[statName]
        titleStr = statSpecTitleStr[statName]
        dsList = ds[statName]
        dsStr = ''
        cdefStr = ''
        color_idx = 0
        for dsName in dsList:
            color_idx = color_idx + 1
            colorStr = '#'+colors[color_idx]
            legendStr = dsSpecLegendStr[dsName]
            idx = 0
            for nodeName in nodeNames:
                sidx = "_%d" % idx
                dsStr = dsStr + 'DEF:my'+dsName+sidx+'='+rrd_path+'/'+\
                        nodeName+'.rrd:'+dsName+':AVERAGE '
                idx = idx + 1

            cdefStr = cdefStr + 'CDEF:'+dsName+'_sum1=0,my'+dsName+'_0,+ '
            for n in range(2, (len(nodeNames)+1)):
                sn = "%d" % n
                snm1 = "%d" % (n-1)
                cdefStr = cdefStr + 'CDEF:'+dsName+'_sum'+sn+'='+\
                          dsName+'_sum'+snm1+',my'+dsName+'_'+snm1+',+ '
            snumnodes = "%d" % len(nodeNames)

            if len(cdef[dsName]):
                cdefStr = cdefStr + 'CDEF:'+dsName+'_avg='+dsName+'_sum'+\
                          snumnodes+','+snumnodes+',/ '+\
                          'CDEF:cdef_'+dsName+'_avg='+dsName+'_avg,100,* '+\
                          'LINE2:cdef_'+dsName+'_avg' +\
                          colorStr+':'+legendStr+' '
            else:
                cdefStr = cdefStr + 'CDEF:'+dsName+'_avg='+dsName+'_sum'+\
                          snumnodes+','+snumnodes+',/ LINE2:'+dsName+'_avg' +\
                          colorStr+':'+legendStr+' '
                
        str = rrdtool_path+'/rrdtool graph '+graphdir+graph+ ' --start -'+\
              start+titleStr+'all '+genericStr+statSpecStr+dsStr+cdefStr
        
#        print str
        commands.getoutput(str)
        print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph=avg_'+statName+'_'+period+'.gif"></tr></td>'
    print '<tr><td><hr></tr></td>'


# Show aggregate for network bandwidth

    print '<tr><td><a NAME="Aggregate"><h2>Aggregate</h2></a></tr></td>'
    for statName in statNames:
        if statName == 'netxfer':
            graph = '/caf/admin/graphs/agg_'+statName+'_'+period+\
                    '.gif'
            statSpecStr = statSpecRRDStr[statName]
            titleStr = statSpecTitleStr[statName]
            dsList = ds[statName]
            dsStr = ''
            cdefStr = ''
            color_idx = 0
            for dsName in dsList:
                color_idx = color_idx + 1
                colorStr = '#'+colors[color_idx]
                legendStr = dsSpecLegendStr[dsName]
                idx = 0
                for nodeName in nodeNames:
                    sidx = "%d" % idx
                    dsStr = dsStr + 'DEF:my'+dsName+sidx+'='+rrd_path+'/'+\
                            nodeName+'.rrd:'+dsName+':AVERAGE '
                    idx = idx + 1

                cdefStr = cdefStr + 'CDEF:'+dsName+'_sum1=0,my'+dsName+'0,+ '
                for n in range(2, (len(nodeNames)+1)):
                    sn = "%d" % n
                    snm1 = "%d" % (n-1)
                    cdefStr = cdefStr + 'CDEF:'+dsName+'_sum'+sn+'='+\
                              dsName+'_sum'+snm1+',my'+dsName+snm1+',+ '
                snumnodes = "%d" % len(nodeNames)

                cdefStr = cdefStr + 'LINE2:'+dsName+'_sum'+snumnodes+\
                          colorStr+':'+legendStr+' '
                
            str = rrdtool_path+'/rrdtool graph '+graphdir+graph+ ' --start -'+\
                  start+titleStr+'all '+genericStr+statSpecStr+dsStr+cdefStr
        
#        print str
            commands.getoutput(str)
            print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph=agg_'+statName+'_'+period+'.gif"></tr></td>'
            print '<tr><td><hr></tr></td>'

    print '<tr><td>Go to statistic:<br>'
    for x in statLabels.values():
        print '<a HREF="#'+x+'">'+x+'</a>'
    print '<br><br></tr></td>'

    # Loop over all requested nodes and statistics to graph
    for statName in statNames:
        print '<tr><td><a NAME="'+statLabels[statName]+'"><h2>'+statLabels[statName]+'</h2></a></tr></td>'
        for nodeName in nodeNames:
            graph = '/caf/admin/graphs/'+nodeName+'_'+statName+'_'+period+\
                    '.gif'
            statSpecStr = statSpecRRDStr[statName]
            if logplot:
                statSpecStr = statSpecStr+'--logarithmic '
            titleStr = statSpecTitleStr[statName]
            dsList = ds[statName]
            dsStr = ''
            color_idx = 0
            for dsName in dsList:
                color_idx = color_idx + 1
                colorStr = '#'+colors[color_idx]
                legendStr = dsSpecLegendStr[dsName]
                cdefStr = cdef[dsName]
                if len(cdefStr):
                    dsStr = dsStr + 'DEF:my'+dsName+'='+rrd_path+'/'+nodeName+\
                            '.rrd:'+dsName+':AVERAGE '+cdefStr+\
                            'LINE2:cdef_my'+dsName+colorStr+':'+legendStr+' '
                else:
                    dsStr = dsStr + 'DEF:my'+dsName+'='+rrd_path+'/'+nodeName+\
                            '.rrd:'+dsName+':AVERAGE LINE2:my'+dsName+\
                            colorStr+':'+legendStr+' '
                
            str = rrdtool_path+'/rrdtool graph '+graphdir+graph+ ' --start -'+\
                  start+titleStr+nodeName+genericStr+statSpecStr+dsStr
#            print str
            commands.getoutput(str)
            print '      <tr><td><img src="http://cdfcaf.fnal.gov/cgi-bin/caf/admin/getgraph.py?graph='+nodeName+'_'+statName+'_'+period+'.gif"></tr></td>'
        print '<tr><td><hr></tr></td>'

    print '    </td></table>'
    print '  </td></tr>'
    print '</table>'

# Main program
if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()

