import urllib
import string
import sys
import getopt

def usage():
    m = "usage:\tgetuser.py nodename [pid] [-v]\n"
    sys.stderr.write(m)
    sys.exit(1)

def geturl(url):
    "Return contents and Mime type of a URL"
    f = urllib.urlopen(url) 
    data = f.read() 
    headers = f.info() 
    f.close() 
    if headers.has_key("content-type"):
        mimetype = headers["content-type"] 
    else:
        # No content-type header -- guess type based on extension 
        if url[-5:] == ".html":
            mimetype = "text/html" 
        else:
            # Don't know -- worst-case assumption 
            mimetype = "application/octet-stream" 
    return (data, mimetype)

if __name__ == '__main__':

    nargs = len(sys.argv)-1
    if (nargs < 2):
        usage()

    try:
        if (nargs == 2):
            opts, pargs = getopt.getopt(sys.argv[2:], 'v')
        else:
            opts, pargs = getopt.getopt(sys.argv[3:], 'v')
    except getopt.error:
        usage()

    PRINT_PAGE = 0
    for eachopts in opts:
        if eachopts[0] == "-v":
            PRINT_PAGE = 1

    node = sys.argv[1]

    if (nargs == 2 and PRINT_PAGE == 1):
        url = "http://cdfcaf.fnal.gov/cgi-bin/caf/getCafUser/getCafUser?node=%s" % node
    else:
        pid  = sys.argv[2]
        url = "http://cdfcaf.fnal.gov/cgi-bin/caf/getCafUser/getCafUser?node=%s&pid=%s" % (node, pid)
    
    rtn = geturl(url)
    webdata = rtn[0]

    if (PRINT_PAGE):
        print webdata

    if (nargs == 3 or PRINT_PAGE == 0):
        user = string.find(webdata, "USER:")
        if user == -1:
            print "No users match this description"
        else:
            print webdata[user+5: string.find(webdata, "<br>", user+5)]


