#!/local/ups/prd/python/v2_1/Linux-2-4/bin/python

from FBS_API import *
import cgi
import popen2
import pickle
import fcntl
import string
import sys


FC = FBSClient() # Getting the FBSClient object

def procTraverse(subProcList):
    procList = []
    for proc in subProcList:
        procList.append([proc.UPID, proc.Command])
        subProc = proc.Subprocesses
        if len(subProc) > 0:
            procList.extend(procTraverse(subProc))
    return procList


MyURL = 'http://cdfcaf.fnal.gov/cgi-bin/caf/admin/graphs.py'
Style = """
<STYLE TYPE="text/css">
<!-- /* Hide from browsers that do not understand CSS */
BODY {
  font-family : Tahoma;
  color : black;
}
TD {
  font-family : Tahoma, Verdana, Arial;
  font-size: 11px;
  color : black;
}
TH {
  font-family : Verdana, Tahoma;
  font-size: 10px;
  font-weight: bold;
  color : black;
}
-->
</STYLE></head>
"""
# Head of HTML page
def htmlHead(title='CDF CAF Find-a-CAF-user', refresh=None):
    print 'Content-type: text/html\nCache-Control: No-cache\n\n'
    print '<html><head>'
    print '<title>%s</title>' % title
    if refresh != None:
        print '<meta http-equiv="refresh" content="%d">' % refresh
    print '</head>'
    print '<body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'
    print '%s' % Style
    print
    print '  <p><table border=0>'
    print '    <tr valign="center">'
    print '    <td width="100"  valign="center" halign="center">'
    print '      <a href="http://cdfcaf.fnal.gov/">'
    print '      <img src="/caf/images/caf_logo.gif" border=0></a></td>'
    print '    <td valign="center" halign="center"><h1><font size=+10>'
    print '      CDF Central Analysis Facility<br></font></h1>'
    print '      <center><h1><font size=+5 color="#AA5500">Find-a-CAF-user</font><h1></center><br></td>'
    print '    </tr>'
    print '  </table>'
    print    
    print '  <hr>'
    print

# Tail of HTML page
def htmlTail():
    print '<hr><font size="-2"><center>'
    print '<a href="http://www-isd.fnal.gov/fcs/">FCS Group</a> | <a href="http://www-isd.fnal.gov/fbsng/">FBSNG</a>'
    print '</center>'
    print '</body></html>'

# Body of HTML page
def htmlBody():

    # Store parameter strings pass to CGI script
    queue = cgi.FieldStorage()

    node_req = None
    pid_req  = None
    for name in queue.keys():
        if name == 'node':
            node_req = queue[name].value
        elif name == 'pid':
            pid_req = queue[name].value

    if (node_req == None):
        print "You must specify a node"

    else:
        print "NODE: %s <br>" % node_req
        print "<br>"
        nodeInfo = FC.getNode(node_req)
        processList = nodeInfo.Processes
        for eachProcess in processList:
            processInfo = FC.getProcess(eachProcess, 1)
            procList = procTraverse(processInfo.Subprocesses)
            startInd = string.find(eachProcess, '.')
            endInd = string.find(eachProcess, '_')
            name = eachProcess[startInd + 1 : endInd]
            if (pid_req == None):
                print "USER: %s <br>" % name
            for proc in procList:
                pid = proc[0]
                exe = proc[1]
                if (pid_req != None):
                    if (int(pid_req) == pid):
                        print "USER: %s <br>" % name
                        print " PID: %s <br>" % pid
                        print "EXEC: %s <br>" % exe
                else:
                    print "PID: %s     EXEC: %s <br>" % (pid, exe)
            print "<br>"


# Main program
if __name__ == '__main__':
    htmlHead()
    htmlBody()
    htmlTail()
