#!/local/ups/prd/python/v2_1/Linux-2-4/bin/python

from FBS_API import *
import popen2
import pickle
import fcntl
import string
import sys


FC = FBSClient() # Getting the FBSClient object

def usage():
    m = "usage:\tgetCafUser.py nodename [pid]\n"
    sys.stderr.write(m)
    sys.exit(1)

    
def procTraverse(subProcList):
    procList = []
    for proc in subProcList:
        procList.append([proc.UPID, proc.Command])
        subProc = proc.Subprocesses
        if len(subProc) > 0:
            procList.extend(procTraverse(subProc))
    return procList


def main():
    nargs = len(sys.argv)-1
    if (nargs < 1):
        usage()

    nodename = sys.argv[1]
    
    pid_req=0
    if (nargs == 2):
        pid_req = sys.argv[2]

    nodeInfo = FC.getNode(nodename)
    processList = nodeInfo.Processes
    for eachProcess in processList:
        processInfo = FC.getProcess(eachProcess, 1)
        procList = procTraverse(processInfo.Subprocesses)
        startInd = string.find(eachProcess, '.')
        endInd = string.find(eachProcess, '_')
        name = eachProcess[startInd + 1 : endInd]
        if (not pid_req):
            print "USER: %s" % name
        for proc in procList:
            pid = proc[0]
            exe = proc[1]
            if (pid_req):
                if (int(pid_req) == pid):
                    print "USER: %s" % name
                    print " PID: %s" % pid
                    print "EXEC: %s" % exe
            else:
                print "\tPID: %s\tEXEC: %s" % (pid, exe)


if __name__ == '__main__':
    main()
