#!/local/ups/prd/python/v2_1/Linux-2-4/bin/python

import cgi
import os
import commands
import time
import string
import sys
import popen2
import random


#
# Global Variables:
#

GlobalDir = "/home/cafmon/fbsmon/graphs_and_images/global"
RRDTOOL_BIN = "/home/cafmon/bin/rrdtool"
RRD_DATA_ROOT = "/home/cafmon/batchmon/RRD"


# class definitions - cur, pass (dummy classes)
#

class cur:
    pass

class avg:
    pass


# class definition - TableData
#

class tableData:

    def __init__(self):

        self.cur = cur()
        self.cur.dataEntryTime = 0.
        self.cur.pending = {}
        self.cur.running = {}
        self.cur.wait_time = {}
        self.cur.start_time_diff = {}
        self.cur.exec_time = {}

        self.avg = avg()
        self.avg.pending = {}
        self.avg.running = {}
        self.avg.wait_time = {}
        self.avg.start_time_diff = {}
        self.avg.exec_time = {}


    # Method definition - get
    #

    def get(self, period="1day"):

        rrdFile = os.path.join(RRD_DATA_ROOT, "pending.rrd")
        self.cur.dataEntryTime, curList, avgList = self.getDataFromRRD(rrdFile, period)

        self.cur.pending["short"], self.cur.pending["medium"], self.cur.pending["long"], \
                                   self.cur.pending["groups"], self.cur.pending["other"] = curList
        if avgList != None:
            self.avg.pending["short"], self.avg.pending["medium"], self.avg.pending["long"], \
                                       self.avg.pending["groups"], self.avg.pending["other"] = avgList
        else:
            self.avg.pending["short"], self.avg.pending["medium"], self.avg.pending["long"], \
                                       self.avg.pending["groups"], self.avg.pending["other"] = (None, None, None, None, None)

        rrdFile = os.path.join(RRD_DATA_ROOT, "running.rrd")
        self.cur.dataEntryTime, curList, avgList = self.getDataFromRRD(rrdFile, period)
        self.cur.running["short"], self.cur.running["medium"], self.cur.running["long"], \
                                   self.cur.running["groups"], self.cur.running["other"] = curList
        if avgList != None:
            self.avg.running["short"], self.avg.running["medium"], self.avg.running["long"], \
                                       self.avg.running["groups"], self.avg.running["other"] = avgList
        else:
            self.avg.running["short"], self.avg.running["medium"], self.avg.running["long"], \
                                       self.avg.running["groups"], self.avg.running["other"] = (None, None, None, None, None)

        rrdFile = os.path.join(RRD_DATA_ROOT, "wait_time.rrd")
        self.cur.dataEntryTime, curList, avgList = self.getDataFromRRD(rrdFile, period)
	if curList != None:
	    self.cur.wait_time["short"], self.cur.wait_time["medium"], self.cur.wait_time["long"], \
					 self.cur.wait_time["groups"], self.cur.wait_time["other"] = curList
	else:
	    self.cur.wait_time["short"], self.cur.wait_time["medium"], self.cur.wait_time["long"], \
					 self.cur.wait_time["groups"], self.cur.wait_time["other"] = (None, None, None, None, None)
        if avgList != None:
            self.avg.wait_time["short"], self.avg.wait_time["medium"], self.avg.wait_time["long"], \
                                         self.avg.wait_time["groups"], self.avg.wait_time["other"] = avgList
        else:
            self.avg.wait_time["short"], self.avg.wait_time["medium"], self.avg.wait_time["long"], \
                                         self.avg.wait_time["groups"], self.avg.wait_time["other"] = (None, None, None, None, None)

        rrdFile = os.path.join(RRD_DATA_ROOT, "start_time_diff.rrd")
        self.cur.dataEntryTime, curList, avgList = self.getDataFromRRD(rrdFile, period)
        self.cur.start_time_diff["short"], self.cur.start_time_diff["medium"], self.cur.start_time_diff["long"], \
                                           self.cur.start_time_diff["groups"], self.cur.start_time_diff["other"] = curList
        
        if avgList != None:
            self.avg.start_time_diff["short"], self.avg.start_time_diff["medium"], self.avg.start_time_diff["long"], \
                                               self.avg.start_time_diff["groups"], self.avg.start_time_diff["other"] = avgList
        else:
            self.avg.start_time_diff["short"], self.avg.start_time_diff["medium"], self.avg.start_time_diff["long"], \
                                               self.avg.start_time_diff["groups"], self.avg.start_time_diff["other"] = (None, None, None, None, None)
            
        rrdFile = os.path.join(RRD_DATA_ROOT, "exec_time.rrd")
        self.cur.dataEntryTime, curList, avgList = self.getDataFromRRD(rrdFile, period)
        self.cur.exec_time["short"], self.cur.exec_time["medium"], self.cur.exec_time["long"], \
                                     self.cur.exec_time["groups"], self.cur.exec_time["other"] = curList
        if avgList != None:
            self.avg.exec_time["short"], self.avg.exec_time["medium"], self.avg.exec_time["long"], \
                                         self.avg.exec_time["groups"], self.avg.exec_time["other"] = avgList
        else:
            self.avg.exec_time["short"], self.avg.exec_time["medium"], self.avg.exec_time["long"], \
                                         self.avg.exec_time["groups"], self.avg.exec_time["other"] = (None, None, None, None, None)


    # Method definition - getDataFromRRD
    #

    def getDataFromRRD(self, rrdFile, period):

        command = "%s fetch %s AVERAGE --start -%s" % (RRDTOOL_BIN, rrdFile, period)
        childout, childin, childerr = popen2.popen3(command)
        childin.close()
        tempOut = childout.readlines()
        childout.close()
        tempErr = childerr.readlines()
        childerr.close()
        
        dataTimeList = []
        shortList    = []
        mediumList   = []
        longList     = []
        groupsList   = []
        otherList    = []

        for line in tempErr:
            line = string.strip(line)

        numDataLines, numValidDataLines = (0, 0)
        for line in tempOut:
            line = string.strip(line)

            if string.find(line, ":") != -1:
                dataTime, dataStr = string.split(line, ":")
                numDataLines += 1
                if dataStr != " nan nan nan nan nan":
                    short, medium, long, groups, other = string.split(dataStr)
                    numValidDataLines += 1
                    if string.strip(dataTime) != "nan":
                        dataTimeList.append(dataTime)
                    if string.strip(short) != "nan":
                        shortList.append(short)
                    if string.strip(medium) != "nan":
                        mediumList.append(medium)
                    if string.strip(long) != "nan":
                        longList.append(long)
                    if string.strip(groups) != "nan":
                        groupsList.append(groups)
                    if string.strip(other) != "nan":
                        otherList.append(other)

#sb     if numDataLines == 0:
        if numValidDataLines == 0:
            return None, None, None
        
        curTime = dataTimeList[len(dataTimeList)-1]
	if len(shortList)>0 & len(mediumList)>0 & len(longList)>0 & len(groupsList)>0 & len(otherList)>0:
	    curList = (shortList[len(shortList)-1], mediumList[len(mediumList)-1], longList[len(longList)-1], groupsList[len(groupsList)-1], otherList[len(otherList)-1])
	else:
	    curList = (None, None, None, None, None)
	
	if len(shortList)>0: curShort = shortList[len(shortList)-1]
	else: curShort="0.0"
	if len(mediumList)>0: curMedium = mediumList[len(mediumList)-1]
	else: curMedium="0.0"
	if len(longList)>0: curLong = longList[len(longList)-1]
	else: curLong="0.0"
	if len(groupsList)>0: curGroups = groupsList[len(groupsList)-1]
	else: curGroups="0.0"
	if len(otherList)>0: curOther = otherList[len(otherList)-1]
	else: curOther="0.0"
	curList = (curShort, curMedium, curLong, curGroups, curOther)
        if float(numValidDataLines) / float(numDataLines) < 0.5:
            return curTime, curList, None
        else:
            avgList = (getAvg(shortList), getAvg(mediumList), getAvg(longList), getAvg(groupsList), getAvg(otherList))
            return curTime, curList, avgList

# Method definition - color
#

def color(i):
    step = 51
    random.seed(i*10000000)
    R = step * ( int(random.random()*6.) )
    G = step * ( int(random.random()*6.) )
    B = step * ( int(random.random()*6.) )
    return "%02X%02X%02X" % (R,G,B)


# Method definition - sortDictByValue
#

_swap2 = lambda (x,y): (y,x)

def sortDictByValue(dict):
    """ Return a list of (key, value) pairs, sorted by value.
    """
    
    mdict = map(_swap2, dict.items())
    mdict.sort()
    mdict.reverse()     # decending order
    mdict = map(_swap2, mdict)

    return mdict


# Method definition - convertSecondsToHourMin
#

def convertSecondsToHourMin(inTime):

    if (inTime!=None):
	inTime = float(inTime)
    else:
	inTime = 0.0

    hours = inTime / 3600.
    secRemain = inTime % 3600.

    mins = secRemain / 60.

    return "%02i:%02i" % (hours, mins)


# Method definition - getAvg
#

def getAvg(list):
    """Calculate average of entries in a given list
    """

    sum = 0.0
    if len(list) < 1:
        return None

    for item in list:
        sum += float(item)

    avg = sum / float(len(list))

    return avg


# Method definition - numSecsInPeriod
#

def numSecsInPeriod(period):

    secsInDay = 60*60*24
    secsInWeek = 7*secsInDay
    secsInMonth = 30*secsInDay
    if period == "1day":
        return secsInDay
    elif period == "3days":
        return 3*secsInDay
    elif period == "1week":
        return secsInWeek
    elif period == "2weeks":
        return 2*secsInWeek
    elif period == "1month":
        return secsInMonth
    elif period == "3months":
        return 3*secsInMonth
    elif period == "1year":
        return 365*secsInDay


# Method definition - GlobalStatus
#

def GlobalStatus(period):


    #
    # --- Global Graph:
    #

    print '<CENTER>'
    print '<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="5" WIDTH="550">'
    print '<TR>'
    print '   <TH VALIGN="top" WIDTH="10%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=gstat&inter=1day">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">day</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=gstat&inter=3days">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">3 days</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=gstat&inter=1week">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">week</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=gstat&inter=2weeks">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">2 weeks</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=gstat&inter=1month">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">month</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="18%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=gstat&inter=3months">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">3 months</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=gstat&inter=1year">' + \
              '<FONT COLOR="#80DBCB" SIZE="+0">year</FONT></A></TH>'
    print '</TR>'
    print '</TABLE>'

    #
    # --- Summary Table:
    #
    PrintSummaryTable(period)

    print '<BR><BR>'

    genGraphsGlobal(period)
    
    print '<FONT COLOR="#000000" SIZE="-1">Built using </FONT><A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank"><FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
    print '</CENTER>'


# Method definition - genGraphsGlobal
#

def genGraphsGlobal(period="1day"):

    
   RRD_ROOT_DIR = "/home/cafmon/batchmon/RRD"
   RRDTOOL_BIN  = "/home/cafmon/bin/rrdtool"

   graphGlobal = "-w 455 -h 150 -c BACK\#000000 -c CANVAS\#111133 -c MGRID\#CCCCCC -c FONT\#00EEBB "

   graphDictGlobal = {
       "pending":"--title=\"Number of Pending Processes\" DEF:val1=%s/pending.rrd:Nshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=%s/pending.rrd:Nmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=%s/pending.rrd:Nlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=%s/pending.rrd:Ngroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=%s/pending.rrd:Nother:AVERAGE LINE2:val5#FF00FF:others CDEF:tot=val1,val2,val3,val4,val5,+,+,+,+ LINE2:tot#aaaaaa:total",
#       "running":"--title=\"Number of Running Processes\" --lower-limit=0. --upper-limit=100. --rigid DEF:val1=%s/running.rrd:Nshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=%s/running.rrd:Nmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=%s/running.rrd:Nlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=%s/running.rrd:Ngroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=%s/running.rrd:Nother:AVERAGE LINE2:val5#FF00FF:others CDEF:tot=val1,val2,val3,val4,val5,+,+,+,+ LINE2:tot#aaaaaa:total",
       "running":"--title=\"Number of Running Processes\" --lower-limit=0. --rigid DEF:val1=%s/running.rrd:Nshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=%s/running.rrd:Nmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=%s/running.rrd:Nlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=%s/running.rrd:Ngroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=%s/running.rrd:Nother:AVERAGE LINE2:val5#FF00FF:others CDEF:tot=val1,val2,val3,val4,val5,+,+,+,+ LINE2:tot#aaaaaa:total",
       "wait_time":"--title=\"Wait Time for Job to Start\" --units-exponent=0 --vertical-label=\"time (hours)\" DEF:val1=%s/wait_time.rrd:Tshort:AVERAGE CDEF:cval1=val1,3600.,/ LINE2:cval1#FFFF00:short DEF:val2=%s/wait_time.rrd:Tmedium:AVERAGE CDEF:cval2=val2,3600.,/ LINE2:cval2#BB0000:medium DEF:val3=%s/wait_time.rrd:Tlong:AVERAGE CDEF:cval3=val3,3600.,/ LINE2:cval3#3333FF:long DEF:val4=%s/wait_time.rrd:Tgroups:AVERAGE CDEF:cval4=val4,3600.,/ LINE2:cval4#00FF00:groups DEF:val5=%s/wait_time.rrd:Tother:AVERAGE CDEF:cval5=val5,3600.,/ LINE2:cval5#FF00FF:others",
       "start_time_diff":"--title=\"Time Difference Between Processes Starting\" --units-exponent=0 --vertical-label=\"time (hours)\" DEF:val1=%s/start_time_diff.rrd:Tshort:AVERAGE CDEF:cval1=val1,3600.,/ LINE2:cval1#FFFF00:short DEF:val2=%s/start_time_diff.rrd:Tmedium:AVERAGE CDEF:cval2=val2,3600.,/ LINE2:cval2#BB0000:medium DEF:val3=%s/start_time_diff.rrd:Tlong:AVERAGE CDEF:cval3=val3,3600.,/ LINE2:cval3#3333FF:long DEF:val4=%s/start_time_diff.rrd:Tgroups:AVERAGE CDEF:cval4=val4,3600.,/ LINE2:cval4#00FF00:groups DEF:val5=%s/start_time_diff.rrd:Tother:AVERAGE CDEF:cval5=val5,3600.,/ LINE2:cval5#FF00FF:others",
       "exec_time":"--title=\"Process Execution Time\" --units-exponent=0 --vertical-label=\"time (hours)\" DEF:val1=%s/exec_time.rrd:Tshort:AVERAGE CDEF:cval1=val1,3600.,/ LINE2:cval1#FFFF00:short DEF:val2=%s/exec_time.rrd:Tmedium:AVERAGE CDEF:cval2=val2,3600.,/ LINE2:cval2#BB0000:medium DEF:val3=%s/exec_time.rrd:Tlong:AVERAGE CDEF:cval3=val3,3600.,/ LINE2:cval3#3333FF:long DEF:val4=%s/exec_time.rrd:Tgroups:AVERAGE CDEF:cval4=val4,3600.,/ LINE2:cval4#00FF00:groups DEF:val5=%s/exec_time.rrd:Tother:AVERAGE CDEF:cval5=val5,3600.,/ LINE2:cval5#FF00FF:others"
       }

   dataTypes = ["pending", "running", "wait_time", "start_time_diff", "exec_time"]

   startStr = " --start -%s " % period

   for dataType in dataTypes:

       if dataType == "wait_time":
           print '<br><br>'
       
       graphFile = "/var/www/cgi-bin/caf/userMon/graphs/%s_%s.gif" % (dataType, period)
       graphStr = graphGlobal + startStr + (graphDictGlobal[dataType] % (RRD_ROOT_DIR, RRD_ROOT_DIR, RRD_ROOT_DIR, RRD_ROOT_DIR, RRD_ROOT_DIR))
       
       command = "%s graph %s %s" % (RRDTOOL_BIN, graphFile, graphStr)
       commands.getoutput(command)
       print '<img src="http://cdfmon.cr.cnaf.infn.it:8081/cgi-bin/caf/userMon/getgraph.py?graph=%s_%s.gif"></tr></td><BR>' % (dataType, period)

                   
# Method definition - PrintSummaryTable
#

def PrintSummaryTable(period):


    td = tableData()
    td.get()         # default is last day, to be used to get current data

    # convert strings to desired format for printing
    if td.cur.exec_time["short"] != None:
        currentPendingShort  = str(int(eval(td.cur.pending["short"])))
        currentPendingMedium = str(int(eval(td.cur.pending["medium"])))
        currentPendingLong   = str(int(eval(td.cur.pending["long"])))
        currentPendingGroups = str(int(eval(td.cur.pending["groups"])))
        currentPendingOther  = str(int(eval(td.cur.pending["other"])))
        currentPendingTotal  = str(int(eval(td.cur.pending["short"]) + eval(td.cur.pending["medium"]) + eval(td.cur.pending["long"]) \
                               + eval(td.cur.pending["groups"]) + eval(td.cur.pending["other"])))
        
        currentRunningShort  = str(int(eval(td.cur.running["short"])))
        currentRunningMedium = str(int(eval(td.cur.running["medium"])))
        currentRunningLong   = str(int(eval(td.cur.running["long"])))
        currentRunningGroups = str(int(eval(td.cur.running["groups"])))
        currentRunningOther  = str(int(eval(td.cur.running["other"])))
        currentRunningTotal  = str(int(eval(td.cur.running["short"]) + eval(td.cur.running["medium"]) + eval(td.cur.running["long"]) \
                               + eval(td.cur.running["groups"]) + eval(td.cur.running["other"])))
    
        currentWaitTimeShort  = convertSecondsToHourMin(eval(td.cur.wait_time["short"]))
        currentWaitTimeMedium = convertSecondsToHourMin(eval(td.cur.wait_time["medium"]))
        currentWaitTimeLong   = convertSecondsToHourMin(eval(td.cur.wait_time["long"]))
        currentWaitTimeGroups = convertSecondsToHourMin(eval(td.cur.wait_time["groups"]))
        currentWaitTimeOther  = convertSecondsToHourMin(eval(td.cur.wait_time["other"]))
        
        currentStartTimeDiffShort  = convertSecondsToHourMin(eval(td.cur.start_time_diff["short"]))
        currentStartTimeDiffMedium = convertSecondsToHourMin(eval(td.cur.start_time_diff["medium"]))
        currentStartTimeDiffLong   = convertSecondsToHourMin(eval(td.cur.start_time_diff["long"]))
        currentStartTimeDiffGroups = convertSecondsToHourMin(eval(td.cur.start_time_diff["groups"]))
        currentStartTimeDiffOther  = convertSecondsToHourMin(eval(td.cur.start_time_diff["other"]))
    
        currentExecTimeShort  = convertSecondsToHourMin(eval(td.cur.exec_time["short"]))
        currentExecTimeMedium = convertSecondsToHourMin(eval(td.cur.exec_time["medium"]))
        currentExecTimeLong   = convertSecondsToHourMin(eval(td.cur.exec_time["long"]))
        currentExecTimeGroups = convertSecondsToHourMin(eval(td.cur.exec_time["groups"]))
        currentExecTimeOther  = convertSecondsToHourMin(eval(td.cur.exec_time["other"]))

    else:
        
        currentPendingShort  = "N/A" 
        currentPendingMedium = "N/A" 
        currentPendingLong   = "N/A"
        currentPendingGroups = "N/A" 
        currentPendingOther  = "N/A" 
        
        currentRunningShort  = "N/A"
        currentRunningMedium = "N/A"
        currentRunningLong   = "N/A" 
        currentRunningGroups = "N/A" 
        currentRunningOther  = "N/A"
    
        currentWaitTimeShort  = "N/A" 
        currentWaitTimeMedium = "N/A"
        currentWaitTimeLong   = "N/A" 
        currentWaitTimeGroups = "N/A" 
        currentWaitTimeOther  = "N/A"
        
        currentStartTimeDiffShort  = "N/A"
        currentStartTimeDiffMedium = "N/A"
        currentStartTimeDiffLong   = "N/A"
        currentStartTimeDiffGroups = "N/A"
        currentStartTimeDiffOther  = "N/A"
    
        currentExecTimeShort  = "N/A"
        currentExecTimeMedium = "N/A"
        currentExecTimeLong   = "N/A"
        currentExecTimeGroups = "N/A"
        currentExecTimeOther  = "N/A"

        currentPendingTotal = "N/A"
        currentRunningTotal = "N/A"

    td.get(period)

    if td.avg.exec_time["short"] != None:
    
        avgPendingShort  = str(int(td.avg.pending["short"]))
        avgPendingMedium = str(int(td.avg.pending["medium"]))
        avgPendingLong   = str(int(td.avg.pending["long"]))
        avgPendingGroups = str(int(td.avg.pending["groups"]))
        avgPendingOther  = str(int(td.avg.pending["other"]))
        avgPendingTotal  = str(int(td.avg.pending["short"] + td.avg.pending["medium"] + td.avg.pending["long"] \
                               + td.avg.pending["groups"] + td.avg.pending["other"]))
        
        avgRunningShort  = str(int(td.avg.running["short"]))
        avgRunningMedium = str(int(td.avg.running["medium"]))
        avgRunningLong   = str(int(td.avg.running["long"]))
        avgRunningGroups = str(int(td.avg.running["groups"]))
        avgRunningOther  = str(int(td.avg.running["other"]))
        avgRunningTotal  = str(int(td.avg.running["short"] + td.avg.running["medium"] + td.avg.running["long"] \
                               + td.avg.running["groups"] + td.avg.running["other"]))
        
        avgWaitTimeShort  = convertSecondsToHourMin(td.avg.wait_time["short"])
        avgWaitTimeMedium = convertSecondsToHourMin(td.avg.wait_time["medium"])
        avgWaitTimeLong   = convertSecondsToHourMin(td.avg.wait_time["long"])
        avgWaitTimeGroups = convertSecondsToHourMin(td.avg.wait_time["groups"])
        avgWaitTimeOther  = convertSecondsToHourMin(td.avg.wait_time["other"])
        
        avgStartTimeDiffShort  = convertSecondsToHourMin(td.avg.start_time_diff["short"])
        avgStartTimeDiffMedium = convertSecondsToHourMin(td.avg.start_time_diff["medium"])
        avgStartTimeDiffLong   = convertSecondsToHourMin(td.avg.start_time_diff["long"])
        avgStartTimeDiffGroups = convertSecondsToHourMin(td.avg.start_time_diff["groups"])
        avgStartTimeDiffOther  = convertSecondsToHourMin(td.avg.start_time_diff["other"])
        
        avgExecTimeShort  = convertSecondsToHourMin(td.avg.exec_time["short"])
        avgExecTimeMedium = convertSecondsToHourMin(td.avg.exec_time["medium"])
        avgExecTimeLong   = convertSecondsToHourMin(td.avg.exec_time["long"])
        avgExecTimeGroups = convertSecondsToHourMin(td.avg.exec_time["groups"])
        avgExecTimeOther  = convertSecondsToHourMin(td.avg.exec_time["other"])
        
    else:

        avgPendingShort  = "N/A"
        avgPendingMedium = "N/A"
        avgPendingLong   = "N/A"
        avgPendingGroups = "N/A"
        avgPendingOther  = "N/A"
        
        avgRunningShort  = "N/A"
        avgRunningMedium = "N/A"
        avgRunningLong   = "N/A"
        avgRunningGroups = "N/A"
        avgRunningOther  = "N/A"
        
        avgWaitTimeShort  = "N/A"
        avgWaitTimeMedium = "N/A"
        avgWaitTimeLong   = "N/A"
        avgWaitTimeGroups = "N/A"
        avgWaitTimeOther  = "N/A"
        
        avgStartTimeDiffShort  = "N/A"
        avgStartTimeDiffMedium = "N/A"
        avgStartTimeDiffLong   = "N/A"
        avgStartTimeDiffGroups = "N/A"
        avgStartTimeDiffOther  = "N/A"
        
        avgExecTimeShort  = "N/A"
        avgExecTimeMedium = "N/A"
        avgExecTimeLong   = "N/A"
        avgExecTimeGroups = "N/A"
        avgExecTimeOther  = "N/A"
        
        avgPendingTotal = "N/A"
        avgRunningTotal = "N/A"
        


    print '<P>'
    print '<CENTER>'
    print '<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="550">'
    print '<TR>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">&nbsp;</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133" COLSPAN=2><FONT COLOR="#80DBCB" SIZE="-1">Pending </FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133" COLSPAN=2><FONT COLOR="#80DBCB" SIZE="-1">Running </FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133" COLSPAN=2><FONT COLOR="#80DBCB" SIZE="-1">Wait time </FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133" COLSPAN=2><FONT COLOR="#80DBCB" SIZE="-1">Start time diff </FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133" COLSPAN=2><FONT COLOR="#80DBCB" SIZE="-1">Exec time </FONT></TH>'
    print '</TR>'

    print '<TR>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">&nbsp;</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Current</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Avg</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Current</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Avg</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Current</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Avg</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Current</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Avg</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Current</FONT></TH>'
    print '   <TH VALIGN="center" HALIGN="center" WIDTH="5%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB" SIZE="-1">Avg</FONT></TH>'
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA">&nbsp;&nbsp;&nbsp;<FONT COLOR="#0000EE"><B>Short</B></FONT></TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentPendingShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgPendingShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentRunningShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgRunningShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentWaitTimeShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgWaitTimeShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentStartTimeDiffShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgStartTimeDiffShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentExecTimeShort
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgExecTimeShort
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC">&nbsp;&nbsp;&nbsp;<FONT COLOR="#0000EE"><B>Medium</B></FONT></TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentPendingMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgPendingMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentRunningMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgRunningMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentWaitTimeMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgWaitTimeMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentStartTimeDiffMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgStartTimeDiffMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentExecTimeMedium
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgExecTimeMedium
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA">&nbsp;&nbsp;&nbsp;<FONT COLOR="#0000EE"><B>Long</B></FONT></TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentPendingLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgPendingLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentRunningLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgRunningLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentWaitTimeLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgWaitTimeLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentStartTimeDiffLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgStartTimeDiffLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentExecTimeLong
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgExecTimeLong
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC">&nbsp;&nbsp;&nbsp;<FONT COLOR="#0000EE"><B>Groups</B></FONT></TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentPendingGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgPendingGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentRunningGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgRunningGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentWaitTimeGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgWaitTimeGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentStartTimeDiffGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgStartTimeDiffGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentExecTimeGroups
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgExecTimeGroups
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA">&nbsp;&nbsp;&nbsp;<FONT COLOR="#0000EE"><B>Other</B></FONT></TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentPendingOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgPendingOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentRunningOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgRunningOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentWaitTimeOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgWaitTimeOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentStartTimeDiffOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgStartTimeDiffOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentExecTimeOther
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#AAAAAA"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgExecTimeOther
    print '</TR>'

    print '<TR>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#EEEEEE">&nbsp;&nbsp;&nbsp;Total</TD>'
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#EEEEEE"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentPendingTotal
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#EEEEEE"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgPendingTotal
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#EEEEEE"><FONT SIZE=+0> <CENTER><B>%s</B></CENTER></FONT></TD>' % currentRunningTotal
    print '   <TD VALIGN="center" HEIGHT=35 BGCOLOR="#EEEEEE"><FONT SIZE=+0 COLOR="#CD2626"> <CENTER>%s</CENTER></FONT></TD>' % avgRunningTotal
    print '   <TD COLSPAN=6" ALIGN="right" VALIGN="top" BGCOLOR="#80DDCB"><FONT COLOR="#000000" SIZE="-1"><B>Last updated: %s</B></FONT></TD>' % time.ctime(eval(td.cur.dataEntryTime))
    print '</TR>'

    print '</TABLE>'
    print '</CENTER>'
                 

# Method definition - userSummary
#

def userSummary(period="1day"):

    print '<CENTER><FONT COLOR="#111133"><H2>CAF users</H2></FONT>'
    print '<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="5" WIDTH="550">'
    print '<TR>'

    print '   <TH VALIGN="top" WIDTH="10%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=userSummary&inter=1day" TARGET="mbody"><FONT COLOR="#80DBCB" SIZE="+0">day</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=userSummary&inter=3days"><FONT COLOR="#80DBCB" SIZE="+0">3 days</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=userSummary&inter=1week"><FONT COLOR="#80DBCB" SIZE="+0">week</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=userSummary&inter=2weeks"><FONT COLOR="#80DBCB" SIZE="+0">2 weeks</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=userSummary&inter=1month"><FONT COLOR="#80DBCB" SIZE="+0">month</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="18%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=userSummary&inter=3months"><FONT COLOR="#80DBCB" SIZE="+0">3 months</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=userSummary&inter=1year"><FONT COLOR="#80DBCB" SIZE="+0">year</FONT></A></TH>'
    print '</TR>'
    print '</TABLE>'

    genGraphActiveUsers(period)

    print '</CENTER>'

    RRD_ROOT_DIR    = "/home/cafmon/batchmon/RRD"
    fileList = os.listdir(RRD_ROOT_DIR)
    userNameList = []
    for fileName in fileList:
        if fileName[:5] == "user_" and fileName[-4:] == ".rrd":
            tmpList = string.split(fileName, ".")
            i = string.find(fileName, tmpList[len(tmpList)-1])
            baseName = fileName[:i-1]
            userName = baseName[5:]
            userNameList.append(userName)
    userNameList.sort()

    period = "1day"

    firstLetterDict = {}
    alphabet = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    for l in alphabet:
        firstLetterDict[l] = 1
        
    col = 1
    for userName in userNameList:
        if firstLetterDict[userName[0]]:
            firstLetterDict[userName[0]] = 0
            print '<br><center><table border=0 width=650>'
            print '<th colspan=5><font size=+1 COLOR="#CD2626"><b>%s</b></font></th>' % userName[0]
            print '<tr><td width="20%"><font size=+1>'
            print '<A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user=%s&inter=%s" target="mbody"> %s </a>' % (userName, period, userName) + '<br>'
            print '</font></td>'
            col = 1
        else:
            print '<td width="20%"><font size=+1>'
            print '<A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user=%s&inter=%s" target="mbody"> %s </a>' % (userName, period, userName) + '<br>'
            print '</font></td>'
        if col == 5:
            print '</tr>'
            col = 1
        else:
            col += 1
            


# Method definition - genGraphActiveUsers
#

def genGraphActiveUsers(period="1day"):


    RRD_ROOT_DIR = "/home/cafmon/batchmon/RRD"
    RRDTOOL_BIN  = "/home/cafmon/bin/rrdtool"
    
    graphGlobalDict = {
        "pending":"-w 455 -h 250 -c BACK\#000000 -c CANVAS\#111133 -c FONT\#00EEBB -c GRID\#000000 --title=\"Number of Pending Processes\" --lower-limit=0",
        "running":"-w 455 -h 250 -c BACK\#000000 -c CANVAS\#111133 -c FONT\#00EEBB -c GRID\#000000 --title=\"Number of Running Processes\" --lower-limit=0",
        }
    
    graphUserDict = {
        "pending":" DEF:val%d=%s/user_%s.rrd:Npending:AVERAGE CDEF:nval%d=val%d,UN,0,val%d,IF LINE2:nval%d%s:%s",
        "running":" DEF:val%d=%s/user_%s.rrd:Nrunning:AVERAGE CDEF:nval%d=val%d,UN,0,val%d,IF LINE2:nval%d%s:%s",
        }
    
    dataTypes = ["pending", "running"]
    
    startStr = " --start -%s" % period
    
    for dataType in dataTypes:

        graphFile = "/var/www/cgi-bin/caf/userMon/graphs/activeUsers_%s_%s.gif" % (dataType, period)
        graphStr = graphGlobalDict[dataType] + startStr

        
        activePendingUserDict, activeRunningUserDict = getActiveUsers(period)
        if dataType == "pending":
            activeUserDict = activePendingUserDict
        elif dataType == "running":
            activeUserDict = activeRunningUserDict
        nActive = len(activeUserDict.keys())

        print '<P>'
        print '<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="550">'

        print '<TR>'
        print '   <TH ALIGN=LEFT HEIGHT=35 BGCOLOR="#FFFFFF" COLSPAN=3><FONT COLOR="#000000" SIZE=+1>Number of users '+dataType+' over last '+period+':</FONT><FONT COLOR="#CD2626" SIZE=+1> '+str(nActive)+'</FONT></TH>'
        print '</TR>'
        
        print '<TR>'
        print '   <TH ALIGN=LEFT HEIGHT=35 BGCOLOR="#FFFFFF" COLSPAN=3><FONT COLOR="000000" SIZE=+1>Top 10 users (by # CPUs) over last '+period+':</FONT></TH>'
        print '</TR>'

        print '<TR>'
        print '   <TH ALIGN=LEFT WIDTH="10%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB">&nbsp;</FONT></TH>'
        print '   <TH ALIGN=LEFT WIDTH="45%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB">User</FONT></TH>'
        print '   <TH ALIGN=LEFT WIDTH="45%" HEIGHT=35 BGCOLOR="#111133"><FONT COLOR="#80DBCB">Avg '+dataType+'</FONT></TH>'
        print '</TR>'
        

        i = 0
        for userName, avgValue in sortDictByValue(activeUserDict):
#            print "%s  %s <br>" % (userName, avgValue)
            i+= 1

            colorStr = "#%s" % color(i)
            graphStr += (graphUserDict[dataType] % (i, RRD_ROOT_DIR, userName, i, i, i, i, colorStr, userName))

            if i <= 10:
                print '<TR>'
                print '   <TD HEIGHT=20 BGCOLOR=%s>&nbsp;</TD>' % colorStr
                print '   <TD HEIGHT=20 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> &nbsp;<A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter='+period+'" target="mbody">'+userName+'</FONT></TD>'
                print '   <TD HEIGHT=20 BGCOLOR="#CCCCCC"><FONT SIZE=+0 COLOR="#CD2626"> '+str(int(avgValue))+'</FONT></TD>'
                print '</TR>'

        print '</TABLE>'

        print '<br>'
        command = "%s graph %s %s" % (RRDTOOL_BIN, graphFile, graphStr)
        commands.getoutput(command)
       
        print '<img src="http://cdfmon.cr.cnaf.infn.it:8081/cgi-bin/caf/userMon/getgraph.py?graph=activeUsers_%s_%s.gif"></tr></td>' % (dataType, period)


# Method definition - getActiveUsers
#

def getActiveUsers(period="1day"):

    RRD_ROOT_DIR = "/home/cafmon/batchmon/RRD"

    activePendingUserDict, activeRunningUserDict = ({}, {})
    
    fileList = os.listdir(RRD_ROOT_DIR)
    for file in fileList:
        if file[:5] == "user_" and file[-4:] == ".rrd":

            rrdFile = os.path.join(RRD_ROOT_DIR, file)
            mtimeDiff = time.time() - os.path.getmtime(rrdFile)
            if mtimeDiff < numSecsInPeriod(period):
            
                tmpList = string.split(file, ".")
                i = string.find(file, tmpList[len(tmpList)-1])
                baseName = file[:i-1]
                userName = baseName[5:]

                command = "%s fetch %s AVERAGE --start -%s" % (RRDTOOL_BIN, rrdFile, period)
                childout, childin, childerr = popen2.popen3(command)
                childin.close()
                tempOut = childout.readlines()
                childout.close()
                tempErr = childerr.readlines()
                childerr.close()
    
                for line in tempErr:
                    line = string.strip(line)
                    print line
                    
                activePending, activeRunning = (0, 0)
                pendingList, runningList = ([], [])
                for line in tempOut:
                    line = string.strip(line)
                    if string.find(line, ":") != -1:
                        dataTime, dataStr = string.split(line, ":")
                        pending, running, wait_time, start_time_diff, exec_time = string.split(dataStr)
                        if pending != "nan":
                            activePending = 1
                            pendingList.append(pending)
                        else:
                            pendingList.append(0.)
                        if running != "nan":
                            activeRunning = 1
                            runningList.append(running)
                        else:
                            runningList.append(0.)

                if activePending:
                    activePendingUserDict[userName] = getAvg(pendingList)
                if activeRunning:
                    activeRunningUserDict[userName] = getAvg(runningList)

    return activePendingUserDict, activeRunningUserDict
        

# Method definition - userStats
#

def userStats(userName, period):

    
    print '<CENTER><FONT COLOR="#111133"><H2>Summary for user '+userName+'</H2></FONT>'
    print '<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="5" WIDTH="550">'
    print '<TR>'

    print '   <TH VALIGN="top" WIDTH="10%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter=1day" TARGET="mbody"><FONT COLOR="#80DBCB" SIZE="+0">day</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter=3days"><FONT COLOR="#80DBCB" SIZE="+0">3 days</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter=1week"><FONT COLOR="#80DBCB" SIZE="+0">week</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter=2weeks"><FONT COLOR="#80DBCB" SIZE="+0">2 weeks</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter=1month"><FONT COLOR="#80DBCB" SIZE="+0">month</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="18%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter=3months"><FONT COLOR="#80DBCB" SIZE="+0">3 months</FONT></A></TH>'
    print '   <TH VALIGN="top" WIDTH="14%" BGCOLOR="#111133"><A HREF="/cgi-bin/caf/userMon/Body.py?opt=ustat&user='+userName+'&inter=1year"><FONT COLOR="#80DBCB" SIZE="+0">year</FONT></A></TH>'
    print '</TR>'
    print '</TABLE>'

    genGraphsUser(userName, period)

    print '</CENTER>'


# Method definition - genGraphsUser
#

def genGraphsUser(userName, period="1day"):

    
   RRD_ROOT_DIR = "/home/cafmon/batchmon/RRD"
   RRDTOOL_BIN  = "/home/cafmon/bin/rrdtool"

   graphDictUser = {
       "pending":"--title=\"Number of Pending Processes\" --units-exponent=0 --lower-limit=0 DEF:val1=%s/user_%s.rrd:Npending:AVERAGE CDEF:nval1=val1,UN,0,val1,IF LINE3:nval1#BB0000:Npending",
       "running":"--title=\"Number of Running Processes\" --units-exponent=0 --lower-limit=0 DEF:val1=%s/user_%s.rrd:Nrunning:AVERAGE CDEF:nval1=val1,UN,0,val1,IF LINE3:nval1#BB0000:Nrunning",
       "wait_time":"--title=\"Wait Time for Job to Start\" --vertical-label=\"time (hours)\" --lower-limit=0 DEF:val1=%s/user_%s.rrd:Twait:AVERAGE CDEF:cval1=val1,3600.,/ LINE3:cval1#3333FF:Twait",
       "start_time_diff":"--title=\"Time Difference Between Processes Starting\" --vertical-label=\"time (hours)\" --units-exponent=0 --upper-limit=0.1 --lower-limit=0 DEF:val1=%s/user_%s.rrd:Tstart:AVERAGE CDEF:cval1=val1,3600.,/ LINE3:cval1#3333FF:Twait",
       "exec_time":"--title=\"Process Execution Time\" --vertical-label=\"time (hours)\" --units-exponent=0 --upper-limit=0.1 --lower-limit=0 DEF:val1=%s/user_%s.rrd:Texec:AVERAGE CDEF:cval1=val1,3600.,/ LINE3:cval1#3333FF:Texec"
    }

   dataTypes = ["pending", "running", "wait_time", "start_time_diff", "exec_time"]

   graphGlobal = ""
   startStr = " --start -%s " % period
   
   for dataType in dataTypes:
       
       graphFile = "/var/www/cgi-bin/caf/userMon/graphs/user_%s_%s_%s.gif" % \
                   (userName, dataType, period)
       
       graphStr = graphGlobal + startStr + \
                  (graphDictUser[dataType] % (RRD_ROOT_DIR, userName))
       
       command = "%s graph %s %s" % (RRDTOOL_BIN, graphFile, graphStr)
        
       commands.getoutput(command)
       print '<img src="http://cdfmon.cr.cnaf.infn.it:8081/cgi-bin/caf/userMon/getgraph.py?graph=user_%s_%s_%s.gif"></tr></td>' % (userName, dataType, period)


# Method definition - CustomGraph
#

def CustomGraph(date1,date2):

    if time.mktime(time.strptime("%s" % date1,"%m/%d/%y")) < 1020232800.0:
        print '<BR><CENTER><H2><FONT COLOR="#000099">No data available before 05/01/02.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m/%d/%y")) > time.time():
        print '<BR><CENTER><H2><FONT COLOR="#000099">Sorry, we do not foresee the Future.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m/%d/%y")) < time.mktime(time.strptime("%s" % date1,"%m/%d/%y")):
        print '<BR><CENTER><H2><FONT COLOR="#000099">ERROR: Starting date is earlier than Ending date!' + \
              '</FONT></H2></CENTER>'
        return
    elif date1 == date2:
        print '<BR><CENTER><H2><FONT COLOR="#000099">Starting and Ending dates coincide.</FONT></H2></CENTER>'
        return
        

    GraphDir = "/caf/users/graphs"
    RRDdir = "/export/home/cafmon/bin"
    DBdir = "/caf/users/db/queues"

    Nnodes = getAvailableNodes()

    pid =  os.getpid()
    FileName = 'graph_total_%s.gif' % pid
    RRDfile = DBdir + '/total.rrd'


    Norm  = 50. / Nnodes
    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )


    CMDstr = '%s/rrdtool graph %s/%s --start %s  --end %s' % (RRDdir,GraphDir,FileName,date1,date2) + \
             ' -v "Used CPUs [%]"  --units-exponent 0 -l 0 -u 100 -r' + \
             ' -w 455 -h 180 -c BACK\#000000 -c CANVAS\#111133 -c MGRID\#CCCCCC -c FONT\#00EEBB' + \
             ' DEF:totR=%s:NrT:AVERAGE CDEF:totRn=totR,%s,\* CDEF:totRn1=totRn,100,GT,100,totRn,IF' % (RRDfile,Norm) + \
             ' DEF:rS=%s:NrS:AVERAGE CDEF:rSn=rS,%s,\*' % (RRDfile,Norm) + \
             ' CDEF:rSn1=rSn,0.1,LT,0,rSn,IF' + \
             ' DEF:rM=%s:NrM:AVERAGE CDEF:rMn=rM,%s,\*' % (RRDfile,Norm) + \
             ' DEF:rL=%s:NrL:AVERAGE CDEF:rLn=rL,%s,\*' % (RRDfile,Norm) + \
             ' CDEF:rLn1=rLn,0.1,LT,0,rLn,IF' + \
             ' DEF:rGSI=%s/italy.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGMI=%s/mit.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGPI=%s/pitt.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGCM=%s/cmu.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGMC=%s/cdfmc.rrd:NrT:AVERAGE' % DBdir  + \
             ' DEF:rGOP=%s/cdfopr.rrd:NrT:AVERAGE' % DBdir + \
             ' CDEF:rgT=rGSI,rGMI,rGPI,rGCM,+,+,+ CDEF:rgT1=rgT,%s,\*' % Norm + \
             ' CDEF:roT=rGMC,rGOP,+ CDEF:roT1=roT,%s,\*' % Norm + \
             ' COMMENT:"----------------------------\\n"' + \
             ' COMMENT:"    ptype        Average % \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE2:rSn\#FFFF00:" Short        "' + \
             ' GPRINT:rSn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' LINE2:rMn\#BB0000:" Medium       "' + \
             ' GPRINT:rMn:AVERAGE:"%8.1lf %s \\n"' +  \
             ' LINE2:rLn\#3333FF:" Long         "' + \
             ' GPRINT:rLn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE2:rgT1\#00FF00:" Groups       "' + \
             ' GPRINT:rgT1:AVERAGE:"%8.2lf %s \\n"' + \
             ' LINE2:roT1\#FF00FF:" Others       "' + \
             ' GPRINT:roT1:AVERAGE:"%8.2lf %s \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE1:totRn1\#FFFFFF:" All processes"' + \
             ' GPRINT:totRn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' COMMENT:"                                                         Created on %s"' % Date
    
    commands.getoutput(CMDstr)


    print '<CENTER>'
    print '   <H2><FONT COLOR="#111133">CAF Global Status from </FONT><FONT COLOR="#CC0000">' + \
          '%s </FONT><FONT COLOR="#111133">to</FONT> <FONT COLOR="#CC0000">%s</FONT></H2>' % (date1,date2)
    print '   <IMG SRC="/caf/userMon/graphs/%s"BORDER="0"><BR>' % FileName
    print '   <FONT COLOR="#000000" SIZE="-1">Built using </FONT><A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank"><FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
    print '</CENTER>'


# Main program
#

def main():
    
    opt = cgi.FieldStorage()

    print 'Content-type: text/html\n\n'
    print '<HTML>'
    print '<HEAD>'
    print '<TITLE>CAF User Monitor</TITLE>'
    print '<META http-equiv="refresh" content="300">'
    print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
    print '</HEAD>'
    
    print '<BODY BGCOLOR="#80DDCB" LINK="#000000" VLINK="#000000" ALINK="#000000">'

    if opt["opt"].value == "gstat":
        GlobalStatus(opt["inter"].value)

    elif opt["opt"].value == "gstatCPU":
        GlobalStatus_CPU(opt["inter"].value)

    elif opt["opt"].value == "actque":
        ActiveQueues()

    elif opt["opt"].value == "userSummary":
        userSummary(opt["inter"].value)

    elif opt["opt"].value == "ustat":
        userStats(opt["user"].value, opt["inter"].value)
        
    else:
        if opt["opt"].value == 'MM/DD/YY':
            print '<BR><CENTER><H2><FONT COLOR="#000099">Please, enter the starting date.</FONT></H2></CENTER>'
            return
        CustomGraph(opt["opt"].value,opt["inter"].value)


    print '</BODY></HTML>'

if __name__ == "__main__":
    main()
