#!/local/ups/prd/python/v2_1/Linux-2-4/bin/python

import cgi
import commands
import os
import sys
import string
import time
import random

DBdir    = "/home/cafmon/fbsmon/db"
RRDdir   = "/home/cafmon/bin"
GraphDir = "/caf/users/graphs"

sys.path.insert(1,"/home/cafmon/fbsmon/script")
from mkTimeHistos import Histo



def CPUgraph(queue,period,type,pnt):

    Nnodes = 67

    pid =  os.getpid()

    graph   = '%s/graph_%s%s%d_%s.gif'   % (GraphDir,period,type,pid,pnt)

    
    if period == 'day':
        dt = ' -s -1d -e N'
    elif period == 'week':
        dt = ' -s -1w -e N'
    elif period == 'month':
        dt = ' -s -1m -e N'

    str1 = '%s/rrdtool graph /tmp' % RRDdir

    str2 = ' --title "%s ' % period
    if type == 'i':
        str2 = str2 + ' (integrated)"'
        str4 = ' -v "Percentage of CPU time"'
    else:
        str2 = str2 + '"'
        str4 = ' -v "Percentage of used CPUs"'

    if pnt == 1:
        str3 = ' -c BACK#FFFFFF -c CANVAS#FFFFFF -c MGRID#000000  -w  700 -h 400  --units-exponent 1' 
    else:
        str3 = ' -c BACK#000000 -c CANVAS#111133 -c MGRID#CCCCCC -c FONT#00EEBB -w  240 -h 160 --units-exponent 1' 



    str = str1 + graph + str2 + str3 + str4 + dt

    Norm  = 50. / Nnodes

    if period == 'day':
        INorm = Norm / 144.
    if period == 'week':
        INorm = Norm / 288.
    if period == 'month':
        INorm = Norm / 224.
    if pnt == 1:
        if period == 'day':
            INorm = Norm / 288. 
        elif period == 'week':
            INorm = Norm / 576.
        elif period == 'month':
            INorm = Norm/ 576.
        
    k=0
    for user in queue:
        k = k+1
        if type == 'i':
            str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:i%s=%s,UN,0,%s,IF,PREV,UN,0,PREV,IF,+ CDEF:ii%s=i%s,%s,*  LINE2:ii%s#%s:"%s"' % \
                  (user,user,user,user,user,INorm,user,color(k),user)
        else:
            str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:f%s=%s,%s,* LINE2:f%s#%s:"%s"'  % (user,user,Norm,user,color(k),user)


    commands.getoutput(str)
    return graph


def color(i):
    
    step = 51

    random.seed(i*10000000)
    R = step * ( int(random.random()*6.) )
    G = step * ( int(random.random()*6.) )
    B = step * ( int(random.random()*6.) )

    return "%02X%02X%02X" % (R,G,B)


#  def colore(k,prn):

#      Ncol = 24

#      colD = { 0:"AAAAAA", 1:"FFFFFF", 2:"FF00FF", 3:"0000FF", 4:"00FF00", 5:"FF0000", 6:"FFFF00", 7:"00FFFF",
#               8:"FF9999", 9:"990000",10:"009900",11:"000099",12:"999900",13:"990099",14:"009999",15:"999999",
#               16:"000033",17:"FF0033",18:"990033",19:"003300",20:"FF3300",21:"993300",22:"33FFFF",23:"33FF00"}

#      colP = { 0:"990000", 1:"000000", 2:"AAAAAA", 3:"000099", 4:"009999", 5:"990099", 6:"999900", 7:"CC0000",
#               8:"00CC00", 9:"0000CC",10:"33CC00",11:"CCCC00",12:"CC3300",13:"CC0033",14:"0033CC",15:"00CC33",
#               16:"6600FF",17:"66FF00",18:"FF0066",19:"FF6600",20:"00FF66",21:"0066FF",22:"3366FF",23:"6633FF"}

#      j = k % Ncol
    
#      if prn == 0:
#          return colD[j]
#      else:
#          return colP[j]



def CPUusage(queue):

    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )

    print '<center>'
    print '<H2><font color="#000099">click on graph for a printable version</font></H2>'
    print '<table>'
    print '<tr><td align="right" colspan=2>Created on %s</td></tr>' % Date
    print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(queue,'day','',1),CPUgraph(queue,'day','',0))  
    print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraph(queue,'day','i',1),CPUgraph(queue,'day','i',0))  
    print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(queue,'week','',1),CPUgraph(queue,'week','',0))  
    print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraph(queue,'week','i',1),CPUgraph(queue,'week','i',0))  
    print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(queue,'month','',1),CPUgraph(queue,'month','',0))  
    print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraph(queue,'month','i',1),CPUgraph(queue,'month','i',0))  
    print '</table>'
    print 'Built using <a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" target="_blank">RRDTool</a>'
    print '</center>'


def TimeGraphs(queue,period):

    if len(queue) > 1:
        print '<p><CENTER><H2><font color="#000099">Please, select only one queue</font></CENTER></H2>'
        return

    hl = Histo(queue[0],"s")
    hl.Fill(period)
    hl.Plot()
    
    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )

    print '<center>'
    print '<H2><font color="#000099">click on graph to download a postscript version</font></H2>'
    print 'NB: Histograms are filled with all available data per section for the selected queue'
    print '<table>'
    print '<tr><td align="right" colspan=2>Created on %s</td></tr>' % Date
    print '<tr><td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td>' % \
          (hl.GraphFile[0],hl.GraphFile[0])
    print '<td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td></tr>' % \
          (hl.GraphFile[1],hl.GraphFile[1])
    print '<tr><td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td>' % \
          (hl.GraphFile[2],hl.GraphFile[2])
    print '<td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td></tr>' % \
          (hl.GraphFile[3],hl.GraphFile[3])
    print '<tr><td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td>' % \
          (hl.GraphFile[4],hl.GraphFile[4])
    print '<td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td></tr>' % \
          (hl.GraphFile[5],hl.GraphFile[5])

    print '</table>'
    print 'Built using <a href="http://www.gnuplot.info/" target="_blank">GNUplot</a>'
    print '</center>'



def main():

    que = cgi.FieldStorage()

    print 'Content-Type: text/html\n\n'
    print '<html><head>'
    print '<meta http-equiv="refresh" content="300">'
    print '<title>CAF user monitor</title>'           
    print '</head><body bgcolor="#80DDCB" alink="#000000" vlink="#000000" link="#000000">'

    
    if len(que.keys()) < 2:
        print '<p><CENTER><H2><font color="#000099">No queues selected</font></CENTER></H2>'
        return

    queue = []
    for name in que.keys():
        if name != "opt":
            queue.append(que[name].value)

    if que["opt"].value == "CPU usage":
        CPUusage(queue)
    elif que["opt"].value == "W&R times":
        TimeGraphs(queue,period="all")


    print '</body></html>'


if __name__ == "__main__":
    main()
