#!/usr/bin/python
########################################################################################

import cgi
import os
import commands
import time
import string
import sys
import random
sys.path.insert(1,"/local/ups/prd/fbsng/v1_4/Linux/lib")
sys.path.insert(1,"/local/ups/prd/fcslib/v2_1/NULL/lib")
sys.path.insert(1,"/home/cafmon/fbsmon/script")
from mkTimeHistos import Histo
from FBS_API import *

#---------------------------------------------------------------------------
# Global Variables:
#---------------------------------------------------------------------------
DBdir     = "/home/cafmon/fbsmon/db"
RRDdir    = "/home/cafmon/bin"
GraphDir  = "/caf/users/graphs"
GlobalDir = '/caf/users/global'
FBSNGcfg  = "/home/cdfcaf/fbsng/cfg/fbs.cfg"
fc        = FBSClient('FBSmon',FBSNGcfg)
opt       = cgi.FieldStorage()
user      = opt["opt"].value
per1      = opt["per1"].value
per2      = opt["per2"].value
qname     = user
FBSURL    = "http://cdfcaf.fnal.gov/cgi-bin/fbswww/fbswww"
farm      = "CAF"
q         = fc.getQueue(qname)
THBgCol   = '#80cBdD'
LineBgColors = ['#eeeecc','#eeeecc','#eeeecc','#ffffdd','#ffffdd','#ffffdd']
SectionStateColors = {
    'running':'bgcolor="#AAFFAA"',
    'ready':'bgcolor="#DDFF88"',
    'waiting':'bgcolor="#FFDD88"',
    'held':'bgcolor="#88EEEE"',
    'failed':'bgcolor="#DDAA88"',
    'canceled':'bgcolor="#AABBAA"',
    'done':'bgcolor="#AABBAA"',
    'zombie':'bgcolor="#AABBAA"',
    'unknown':''
    }
    
#----------------------------------------------------
def miniUserSummaryTable():
    print '<center><table cellpadding=3 border=0 bgcolor="#EEFFDD"> <!-- Queue stats -->'
    sts = ''
    bg = "#77FF77"
    if q.IsHeld:
        sts = 'Held'
        bg = "#FFFF77"
    if q.IsLocked:
        bg = "#FF7777"
        if sts:
            sts = sts + '+Locked'
        else:
            sts = sts + 'Locked'
    if not sts: 	sts = 'OK'

    print '<tr><td colspan=6 align="center" bgcolor="#80ddcb"><font color="#000023"><b>Quick Summary - queue </b></font></td></tr>'
    print '<tr><td align="right" bgcolor="#80DDCB">Status:</td><td align="center" bgcolor="%s">%s</td>' % \
          (bg, sts)
    print '<td align="right" bgcolor="#80DDCB">Running:</td><td %s>%s</td>' % \
          (SectionStateColors['running'], q.NRunning)
    print '    <td align="right" bgcolor="#80DDCB">Pending:</td><td %s>%s</td></tr>' % \
          (SectionStateColors['ready'], q.NPending)
    print '</table></center> <!-- End of queue stats -->'

#------------------------------------------------------
def getAvailableNodes():
    nodelist = fc.getNodeList()
    ntot = 0
    for node in nodelist:
        n = fc.getNode(node)
        #print n.Name, n.IsUp, n.Class, n.Resources, n.Processes
        if n.IsUp and n.Class == "worker":
            ntot = ntot+1
    return ntot

#------------------------------------------------------
def CPUgraph(user,period,type,pnt):

    Nnodes = 2* getAvailableNodes()
    pid =  os.getpid()
    graph   = '%s/graph_%s%s%d_%s.gif'   % (GraphDir,period,type,pid,pnt)
    
    if period == 'day':
        dt = ' -s -1d -e N'
    elif period == 'week':
        dt = ' -s -1w -e N'
    elif period == 'month':
        dt = ' -s -1m -e N'

    str1 = '%s/rrdtool graph /tmp' % RRDdir

    str2 = ' --title "%s ' % period
    if type == 'i':
        str2 = str2 + ' (integrated)"'
        #str4 = ' -v "Percentage of CPU time"'
        str4 = ' -v "used CPU"'
    else:
        str2 = str2 + '"'
        str4 = ' -v "used CPU"'
        #str4 = ' -v "Percentage of used CPUs"'

    if pnt == 1:
        str3 = ' -c BACK#FFFFFF -c CANVAS#FFFFFF -c MGRID#000000  -w  700 -h 400  --units-exponent 0' 
    else:
        str3 = ' -c BACK#000000 -c CANVAS#111133 -c MGRID#CCCCCC -c FONT#00EEBB -w  200 -h 120 --units-exponent 0' 



    str = str1 + graph + str2 + str3 + str4 + dt


    Norm = 1.
    #Norm  = 50. / Nnodes #this normalization is used to get percentage on y-axis 

    INorm = 1.
##    if period == 'day':
##        INorm = Norm / 144.
##    if period == 'week':
##        INorm = Norm / 288.
##    if period == 'month':
##        INorm = Norm / 224.
##    if pnt == 1:
##        if period == 'day':
##            INorm = Norm / 288. 
##        elif period == 'week':
##            INorm = Norm / 576.
##        elif period == 'month':
##            INorm = Norm/ 576.
        
    if type == 'i':
	    str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:i%s=%s,UN,0,%s,IF,PREV,UN,0,PREV,IF,+ CDEF:ii%s=i%s,%s,*  LINE2:ii%s#%s:"%s"' % \
                  (user,user,user,user,user,INorm,user,color(0),user)
    else:
            str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:f%s=%s,%s,* LINE2:f%s#%s:"%s"'  % (user,user,Norm,user,color(1),user)


    commands.getoutput(str)
    return graph

#------------------------------------------------------
def CPUgraphc(user,period1,period2,type,pnt):

    Nnodes = 2* getAvailableNodes()
    pid =  os.getpid()
    graph   = '%s/graph_%s-%s_%s%d_%s.gif'   % (GraphDir,period1,period2,type,pid,pnt)

    anno = int( "20"+per1[4]+per1[5] )
    mese = int(per1[0]+per1[1])
    giorno = int(per1[2]+per1[3])
    n = [ anno,  mese, giorno, 0, 0, 0, 0, 0, 0 ]
    aper1 = time.strftime('%s', n )
    data1 = per1[0]+per1[1]+"/"+per1[2]+per1[3]+"/"+"20"+per1[4]+per1[5]

    anno = int( "20"+per2[4]+per2[5] )
    mese = int(per2[0]+per2[1])
    giorno = int(per2[2]+per2[3])
    n = [ anno,  mese, giorno, 0, 0, 0, 0, 0, 0 ]
    aper2 = time.strftime('%s', n )
    data2 = per2[0]+per2[1]+"/"+per2[2]+per2[3]+"/"+"20"+per2[4]+per2[5]    

    dt = ' -s %s  -e %s' % (aper1,aper2)

    
#    if period == 'day':
#        dt = ' -s -1d -e N'
#    elif period == 'week':
#        dt = ' -s -1w -e N'
#    elif period == 'month':
#        dt = ' -s -1m -e N'

    str1 = '%s/rrdtool graph /tmp' % RRDdir

    str2 = ' --title "%s-%s ' % (data1,data2)
    if type == 'i':
        str2 = str2 + ' (integrated)"'
        #str4 = ' -v "Percentage of CPU time"'
        str4 = ' -v "used CPU"'
    else:
        str2 = str2 + '"'
        str4 = ' -v "used CPU"'
        #str4 = ' -v "Percentage of used CPUs"'

    if pnt == 1:
        str3 = ' -c BACK#FFFFFF -c CANVAS#FFFFFF -c MGRID#000000  -w  700 -h 400  --units-exponent 0' 
    else:
        str3 = ' -c BACK#000000 -c CANVAS#111133 -c MGRID#CCCCCC -c FONT#00EEBB -w  200 -h 120 --units-exponent 0' 



    str = str1 + graph + str2 + str3 + str4 + dt


    Norm = 1.
    #Norm  = 50. / Nnodes #this normalization is used to get percentage on y-axis 

    INorm = 1.
        
    if type == 'i':
	    str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:i%s=%s,UN,0,%s,IF,PREV,UN,0,PREV,IF,+ CDEF:ii%s=i%s,%s,*  LINE2:ii%s#%s:"%s"' % \
                  (user,user,user,user,user,INorm,user,color(0),user)
    else:
            str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:f%s=%s,%s,* LINE2:f%s#%s:"%s"'  % (user,user,Norm,user,color(1),user)


    commands.getoutput(str)
    return graph


#----------------- SALVATI-----------
def Salvati():
    print '<p>CUSTOM GRAPH<p>'

#   CUSTOM GRAPH
#    GraphDir = "/tmp/caf/users/graphs"
#    RRDdir = "/home/cafmon/bin"
#    DBdir = "/home/cafmon/fbsmon/db/queues"

    Nnodes = getAvailableNodes()

    pid =  os.getpid()
    FileName  = '%s_graph_%s-%s_%s.gif' % (user,per1,per2,pid)
    FileNamei = '%s_graphi_%s-%s_%s.gif' % (user,per1,per2,pid)    
    RRDfile = DBdir + '/%s.rrd' % user


    Norm  = 50. / Nnodes
    #Norm = 2*Nnodes
    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )

    anno = int( "20"+per1[4]+per1[5] )
    mese = int(per1[0]+per1[1])
    giorno = int(per1[2]+per1[3])
    n = [ anno,  mese, giorno, 0, 0, 0, 0, 0, 0 ]
    aper1 = time.strftime('%s', n )

    anno = int( "20"+per2[4]+per2[5] )
    mese = int(per2[0]+per2[1])
    giorno = int(per2[2]+per2[3])
    n = [ anno,  mese, giorno, 0, 0, 0, 0, 0, 0 ]
    aper2 = time.strftime('%s', n )

    dt = ' -s %s  -e %s' % (aper1,aper2)
    str1 = '%s/rrdtool graph /tmp' % RRDdir
    str2 = ' --title "%s - %s ' % (per1,per2)

    if type == 'i':
        str2i = str2 + ' (integrated)"'
        str4i = ' -v "Percentage of CPU time"'
    else:
        str2 = str2 + '"'
        str4 = ' -v "Percentage of used CPUs"'

    str3 = ' -c BACK#000000 -c CANVAS#111133 -c MGRID#CCCCCC -c FONT#00EEBB -w  240 -h 160 --units-exponent 1' 



    str = str1 + FileName + str2 + str3 + str4 + dt
    stri = str1 + FileNamei + str2i + str3 + str4i + dt    

    Norm  = 50. / Nnodes

#    if period == 'day':
#        INorm = Norm / 144.
#    if period == 'week':
#        INorm = Norm / 288.
#    if period == 'month':
#        INorm = Norm / 224.
#    if pnt == 1:
#        if period == 'day':
#            INorm = Norm / 288. 
#        elif period == 'week':
#            INorm = Norm / 576.
#        elif period == 'month':
#            INorm = Norm/ 576.

    INorm = Norm/144
        
    stri = stri + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
           ' CDEF:i%s=%s,UN,0,%s,IF,PREV,UN,0,PREV,IF,+ CDEF:ii%s=i%s,%s,*  LINE2:ii%s#%s:"%s"' % \
           (user,user,user,user,user,INorm,user,color(0),user)
    str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
          ' CDEF:f%s=%s,%s,* LINE2:f%s#%s:"%s"'  % (user,user,Norm,user,color(1),user)


    commands.getoutput(str)

    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td>' % (FileName,FileName)
    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td></tr>' % (FileNamei,FileNamei)


#    CMDstr = '%s/rrdtool graph %s/%s --start %s  --end %s' % (RRDdir,GraphDir,FileName,date1,date2) + \
#             ' -v "Used CPUs [%]"  --units-exponent 0 -l 0 -u 100 -r' + \
#             ' -w 455 -h 180 -c BACK\#000000 -c CANVAS\#111133 -c MGRID\#CCCCCC -c FONT\#00EEBB' + \
#             ' DEF:totR=%s:NrT:AVERAGE CDEF:totRn=totR,%s,\* CDEF:totRn1=totRn,100,GT,100,totRn,IF' % (RRDfile,Norm) + \
#             ' DEF:rS=%s:NrS:AVERAGE CDEF:rSn=rS,%s,\*' % (RRDfile,Norm) + \
#             ' CDEF:rSn1=rSn,0.1,LT,0,rSn,IF' + \
#             ' DEF:rM=%s:NrM:AVERAGE CDEF:rMn=rM,%s,\*' % (RRDfile,Norm) + \
#             ' DEF:rL=%s:NrL:AVERAGE CDEF:rLn=rL,%s,\*' % (RRDfile,Norm) + \
#             ' CDEF:rLn1=rLn,0.1,LT,0,rLn,IF' + \
#             ' DEF:rGSI=%s/italy.rrd:NrT:AVERAGE' % DBdir + \
#             ' DEF:rGMI=%s/mit.rrd:NrT:AVERAGE' % DBdir + \
#             ' DEF:rGPI=%s/pitt.rrd:NrT:AVERAGE' % DBdir + \
#             ' DEF:rGCM=%s/cmu.rrd:NrT:AVERAGE' % DBdir + \
#             ' DEF:rGMC=%s/cdfmc.rrd:NrT:AVERAGE' % DBdir  + \
#             ' DEF:rGOP=%s/cdfopr.rrd:NrT:AVERAGE' % DBdir + \
#             ' CDEF:rgT=rGSI,rGMI,rGPI,rGCM,+,+,+ CDEF:rgT1=rgT,%s,\*' % Norm + \
#             ' CDEF:roT=rGMC,rGOP,+ CDEF:roT1=roT,%s,\*' % Norm + \
#             ' COMMENT:"----------------------------\\n"' + \
#             ' COMMENT:"    ptype        Average % \\n"' + \
#             ' COMMENT:"----------------------------\\n"' + \
#             ' LINE2:rSn\#FFFF00:" Short        "' + \
#             ' GPRINT:rSn1:AVERAGE:"%8.1lf %s \\n"' + \
#             ' LINE2:rMn\#BB0000:" Medium       "' + \
#             ' GPRINT:rMn:AVERAGE:"%8.1lf %s \\n"' +  \
#             ' LINE2:rLn\#3333FF:" Long         "' + \
#             ' GPRINT:rLn1:AVERAGE:"%8.1lf %s \\n"' + \
#             ' COMMENT:"----------------------------\\n"' + \
#             ' LINE2:rgT1\#00FF00:" Groups       "' + \
#             ' GPRINT:rgT1:AVERAGE:"%8.2lf %s \\n"' + \
#             ' LINE2:roT1\#FF00FF:" Others       "' + \
#             ' GPRINT:roT1:AVERAGE:"%8.2lf %s \\n"' + \
#             ' COMMENT:"----------------------------\\n"' + \
#             ' LINE1:totRn1\#FFFFFF:" All processes"' + \
#             ' GPRINT:totRn1:AVERAGE:"%8.1lf %s \\n"' + \
#             ' COMMENT:"                                                         Created on %s"' % Date
#    
#    commands.getoutput(CMDstr)
#
#
#    print '<CENTER>'
#    print '   <H2><FONT COLOR="#111133">CAF Global Status from </FONT><FONT COLOR="#CC0000">' + \
#          '%s </FONT><FONT COLOR="#111133">to</FONT> <FONT COLOR="#CC0000">%s</FONT></H2>' % (date1,date2)
#    print '   <IMG SRC="/caf/users/graphs/%s"BORDER="0"><BR>' % FileName
#    print '   <FONT COLOR="#000000" SIZE="-1">Built using </FONT><A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank"><FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
#    print '</CENTER>'








#---------------------------------------------------------------------
def CustomGraph():
    date1 = per1
    date2 = per2
    if time.mktime(time.strptime("%s" % date1,"%m/%d/%y")) < 1020232800.0:
        print '<BR><CENTER><H2><FONT COLOR="#000099">No data available before 05/01/02.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m/%d/%y")) > time.time():
        print '<BR><CENTER><H2><FONT COLOR="#000099">Sorry, we do not foresee the Future.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m/%d/%y")) < time.mktime(time.strptime("%s" % date1,"%m/%d/%y")):
        print '<BR><CENTER><H2><FONT COLOR="#000099">ERROR: Starting date is earlier than Ending date!' + \
              '</FONT></H2></CENTER>'
        return
    elif date1 == date2:
        print '<BR><CENTER><H2><FONT COLOR="#000099">Starting and Ending dates coincide.</FONT></H2></CENTER>'
        return
        
#    GraphDir = "/tmp/caf/users/graphs"
#    RRDdir = "/home/cafmon/bin"
#    DBdir = "/home/cafmon/fbsmon/db/queues"

    Nnodes = getAvailableNodes()

    pid =  os.getpid()
    FileName = 'graph_total_%s.gif' % pid
    RRDfile = DBdir + '/total.rrd'


    Norm  = 50. / Nnodes
    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )


    CMDstr = '%s/rrdtool graph %s/%s --start %s  --end %s' % (RRDdir,GraphDir,FileName,date1,date2) + \
             ' -v "Used CPUs [%]"  --units-exponent 0 -l 0 -u 100 -r' + \
             ' -w 455 -h 180 -c BACK\#000000 -c CANVAS\#111133 -c MGRID\#CCCCCC -c FONT\#00EEBB' + \
             ' DEF:totR=%s:NrT:AVERAGE CDEF:totRn=totR,%s,\* CDEF:totRn1=totRn,100,GT,100,totRn,IF' % (RRDfile,Norm) + \
             ' DEF:rS=%s:NrS:AVERAGE CDEF:rSn=rS,%s,\*' % (RRDfile,Norm) + \
             ' CDEF:rSn1=rSn,0.1,LT,0,rSn,IF' + \
             ' DEF:rM=%s:NrM:AVERAGE CDEF:rMn=rM,%s,\*' % (RRDfile,Norm) + \
             ' DEF:rL=%s:NrL:AVERAGE CDEF:rLn=rL,%s,\*' % (RRDfile,Norm) + \
             ' CDEF:rLn1=rLn,0.1,LT,0,rLn,IF' + \
             ' DEF:rGSI=%s/italy.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGMI=%s/mit.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGPI=%s/pitt.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGCM=%s/cmu.rrd:NrT:AVERAGE' % DBdir + \
             ' DEF:rGMC=%s/cdfmc.rrd:NrT:AVERAGE' % DBdir  + \
             ' DEF:rGOP=%s/cdfopr.rrd:NrT:AVERAGE' % DBdir + \
             ' CDEF:rgT=rGSI,rGMI,rGPI,rGCM,+,+,+ CDEF:rgT1=rgT,%s,\*' % Norm + \
             ' CDEF:roT=rGMC,rGOP,+ CDEF:roT1=roT,%s,\*' % Norm + \
             ' COMMENT:"----------------------------\\n"' + \
             ' COMMENT:"    ptype        Average % \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE2:rSn\#FFFF00:" Short        "' + \
             ' GPRINT:rSn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' LINE2:rMn\#BB0000:" Medium       "' + \
             ' GPRINT:rMn:AVERAGE:"%8.1lf %s \\n"' +  \
             ' LINE2:rLn\#3333FF:" Long         "' + \
             ' GPRINT:rLn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE2:rgT1\#00FF00:" Groups       "' + \
             ' GPRINT:rgT1:AVERAGE:"%8.2lf %s \\n"' + \
             ' LINE2:roT1\#FF00FF:" Others       "' + \
             ' GPRINT:roT1:AVERAGE:"%8.2lf %s \\n"' + \
             ' COMMENT:"----------------------------\\n"' + \
             ' LINE1:totRn1\#FFFFFF:" All processes"' + \
             ' GPRINT:totRn1:AVERAGE:"%8.1lf %s \\n"' + \
             ' COMMENT:"                                                         Created on %s"' % Date
    
    commands.getoutput(CMDstr)


    print '<CENTER>'
    print '   <H2><FONT COLOR="#111133">CAF Global Status from </FONT><FONT COLOR="#CC0000">' + \
          '%s </FONT><FONT COLOR="#111133">to</FONT> <FONT COLOR="#CC0000">%s</FONT></H2>' % (date1,date2)
    print '   <IMG SRC="/caf/users/graphs/%s"BORDER="0"><BR>' % FileName
    print '   <FONT COLOR="#000000" SIZE="-1">Built using </FONT><A HREF="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" TARGET="_blank"><FONT COLOR="#000000" SIZE="-1">RRDTool</FONT></A>'
    print '</CENTER>'


#---------------------------------------------------------------------
def color(i):
    step = 51
    random.seed(i*10000000)
    R = step * ( int(random.random()*6.) )
    G = step * ( int(random.random()*6.) )
    B = step * ( int(random.random()*6.) )
    return "%02X%02X%02X" % (R,G,B)

#----------------------------------------------------------------------
def CPUusage2():

#   controling input date
    date1 = per1
    date2 = per2
    if time.mktime(time.strptime("%s" % date1,"%m%d%y")) < 1020232800.0:
        print '<BR><CENTER><H2><FONT COLOR="#000099">No data available before 05/01/02.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m%d%y")) > time.time():
        print '<BR><CENTER><H2><FONT COLOR="#000099">Sorry, we do not foresee the Future.</FONT></H2></CENTER>'
        return
    elif time.mktime(time.strptime("%s" % date2,"%m%d%y")) < time.mktime(time.strptime("%s" % date1,"%m%d%y")):
        print '<BR><CENTER><H2><FONT COLOR="#000099">ERROR: Starting date is earlier than Ending date!' + \
              '</FONT></H2></CENTER>'
        return
    elif date1 == date2:
        print '<BR><CENTER><H2><FONT COLOR="#000099">Starting and Ending dates coincide.</FONT></H2></CENTER>'
        return


    
    # plot 2 graphs (current and integrated) and the user can choose the period 
    Date  = time.strftime('%b %e %X %Y', time.localtime(time.time()) )
    today = time.strftime('%m/%d/%y', time.localtime(time.time()))

    print '<center>'
    #    print '<font color="#000099">click on graph for a printable version</font>'
    print '<table border=0 cols="3">'

    print '<tr><td valign="middle" BGCOLOR="#EEFFDD" width="110"><center><font size=-1><b> Change graph period</b></font><br> <i>NOT YET IMPLEMENTED</i></center><p>'

#OK    print '<FORM action="/cgi-bin/caf/users/User.py?opt=%s" TARGET="mbody" METHOD="get">' % user
#    print '<FORM action="/cgi-bin/caf/users/User.py?opt=%s"  METHOD="get">' % user    
    print '<FORM action="/cgi-bin/caf/users/User.py?opt=%s&per1=%s&per2=%s"  METHOD="get">' % (user,per1,per2)

    #print '   <TR><TD ALIGN="center" VALIGN="middle" WIDTH="105" BGCOLOR="#EEFFDD">'
    print '      <TABLE BORDER="0" CELLPADDING=2 CELLSPACING=0 ALIGN="center" cols="1">'
    print '         <TR VALIGN="middle">'
    print '            <TD ALIGN="left"   VALIGN="middle" WIDTH="94" BGCOLOR="#EEFFAA" NOWRAP>' + \
                       '<SMALL>Starting date:</SMALL></TD>'
    print '         </TR>'
    print '         <TR VALIGN="middle">'
    print '            <TD ALIGN="center" VALIGN="middle" WIDTH="94" BGCOLOR="#EEFFAA" NOWRAP>' + \
                       '<INPUT type="text" size="8" maxlength="8" name="opt" value="MM/DD/YY"></TD>'
    print '         </TR>'
    print '         <TR VALIGN="middle">'
    print '            <TD ALIGN="left"   VALIGN="middle" WIDTH="94" BGCOLOR="#EEFFAA" NOWRAP>' + \
                       '<SMALL>Ending date:</SMALL></TD>'
    print '         </TR>'
    print '         <TR VALIGN="middle">'
    print '            <TD ALIGN="center" VALIGN="middle" WIDTH="94" BGCOLOR="#EEFFAA" NOWRAP>' + \
                       '<INPUT type="text" size="8" maxlength="8" name="inter" value="%s"></TD>' % today
    print '         </TR>'
    print '         <TR VALIGN="middle">'
    print '            <TD ALIGN="center" VALIGN="middle" WIDTH="94" BGCOLOR="#EEFFAA" NOWRAP>' + \
                       '<INPUT type="submit" value="Display" STYLE="background-color:#EEFFAA">'
    print '         </TR>'
    print '      </TABLE>'
    print '</FORM>'
    print '</td>'


    # print '<tr><td align="right" colspan=2>Created on %s</td></tr>' % Date
#    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td>' % \
#          (CPUgraph(user,'day','',1),CPUgraph(user,'day','',0) )  
#    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
#          (CPUgraph(user,'day','i',1),CPUgraph(user,'day','i',0))
#    print '<tr><td width="110"></TD>'
    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraphc(user,per1,per2,'',1),CPUgraphc(user,per1,per2,'',0) )  
    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraphc(user,per1,per2,'i',1),CPUgraphc(user,per1,per2,'i',0))
    #print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
    #      (CPUgraph(user,'week','',1),CPUgraph(user,'week','',0))  
    #print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
    #      (CPUgraph(user,'week','i',1),CPUgraph(user,'week','i',0))  
    #print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
    #      (CPUgraph(user,'month','',1),CPUgraph(user,'month','',0))  
    #print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
    #      (CPUgraph(user,'month','i',1),CPUgraph(user,'month','i',0))  
    print '</table>'
    #print 'Built using <a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" target="_blank">RRDTool</a>'
    print '</center>'




#-----------------------------------------------------------------------
def CPUusage3():

    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )

    print '<center>'
    #print '<font color="#000099">click on graph for a printable version</font>'
    print '<table>'
    #print '<tr><td align="right" colspan=2>Created on %s</td></tr>' % Date
    print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(user,'day','',1),CPUgraph(user,'day','',0) )  
    print '<td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(user,'week','',1),CPUgraph(user,'week','',0))  
    print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraph(user,'month','',1),CPUgraph(user,'month','',0))  
    print '</table>'
    #print '<h6>Built using <a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" target="_blank">RRDTool</a></h6>'
    print '</center>'

#------------------------------------------------------------------------------------------
def CPUusage6():
    # plot 3x2 graphs with D/W/M current and integrated
    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )

    print '<center>'
    print '<font color="#000099">click on graph for a printable version</font>'
    print '<table>'
    print '<tr><td align="right" colspan=2>Created on %s</td></tr>' % Date
    print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(user,'day','',1),CPUgraph(user,'day','',0) )  
    print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraph(user,'day','i',1),CPUgraph(user,'day','i',0))  
    print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(user,'week','',1),CPUgraph(user,'week','',0))  
    print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraph(user,'week','i',1),CPUgraph(user,'week','i',0))  
    print '<tr><td> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraph(user,'month','',1),CPUgraph(user,'month','',0))  
    print '<td> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraph(user,'month','i',1),CPUgraph(user,'month','i',0))  
    print '</table>'
    print 'Built using <a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" target="_blank">RRDTool</a>'
    print '</center>'

#-----------------------------------------------------------------------------------------
def TimeGraphs(queue,period):

    hl = Histo(queue[0],"s")
    hl.Fill(period)
    hl.Plot()
    
    Date = time.strftime('%b %e %X %Y', time.localtime(time.time()) )

    print '<center>'
    print '<H2><font color="#000099">click on graph to download a postscript version</font></H2>'
    print 'NB: Histograms are filled with all available data per section for the selected queue'
    print '<table>'
    print '<tr><td align="right" colspan=2>Created on %s</td></tr>' % Date
    print '<tr><td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td>' % \
          (hl.GraphFile[0],hl.GraphFile[0])
    print '<td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td></tr>' % \
          (hl.GraphFile[1],hl.GraphFile[1])
    print '<tr><td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td>' % \
          (hl.GraphFile[2],hl.GraphFile[2])
    print '<td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td></tr>' % \
          (hl.GraphFile[3],hl.GraphFile[3])
    print '<tr><td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td>' % \
          (hl.GraphFile[4],hl.GraphFile[4])
    print '<td> <a href="%s.ps"><img src="%s.jpeg" border=0></a></td></tr>' % \
          (hl.GraphFile[5],hl.GraphFile[5])

    print '</table>'
    print 'Built using <a href="http://www.gnuplot.info/" target="_blank">GNUplot</a>'
    print '</center>'


#---------------------------------------------------------------------------------
def setGraphName():
#    sys.path.insert(1,"/home/cafmon/fbsmon/script")
#    from mkTimeHistos import Histo

    pid     =  os.getpid()
    period  = "day"
    type    =""
    pnt = "0"
    graph   = '%s/graph_%s%s%d_%s.gif'   % (GraphDir,period,type,pid,pnt)

    dtd = ' -s -1d -e N'
    dtw = ' -s -1w -e N'
    dtm = ' -s -1m -e N'

    str1 = '%s/rrdtool graph /tmp' % RRDdir
    str2 = ' --title "%s ' % period
    if type == 'i':
        str2 = str2 + ' (integrated)"'
        str4 = ' -v "Percentage of CPU time"'
    else:
        str2 = str2 + '"'
        str4 = ' -v "Percentage of used CPUs"'

    if pnt == 1:
        str3 = ' -c BACK#FFFFFF -c CANVAS#FFFFFF -c MGRID#000000  -w  700 -h 400  --units-exponent 1' 
    else:
        str3 = ' -c BACK#000000 -c CANVAS#111133 -c MGRID#CCCCCC -c FONT#00EEBB -w  240 -h 160 --units-exponent 1' 


#    commands.getoutput(str)
#    print '<P>"%s"<p>' % graph
#    print '<P><img src="%s"><p>' % graph

#-----------------------------------------------------------------------------

def SectionsTable():
    print '<table  width="100%" cellpadding=2>'
    print '<tr bgcolor="%s"><th>SectID</th><th>User</th><th>ProcType</th><th>Status</th><th>Prio</th><th>NProc</th><th>Date/Time</th></tr>' %\
          THBgCol
    ibgcol = -1

    nstot = 0
    for sid in q.Sections:
        nstot = nstot+1
        ibgcol = (ibgcol + 1) % len(LineBgColors)
        s = fc.getSection(sid)
        #if ptype != None and s.ProcType != ptype:
        #    continue
        nrun = 0
        for i in range(s.NProc):
            if s.ProcStats[i+1] == 'running':
                nrun = nrun + 1
            nprocstr = '%s/%s' % (nrun, s.NProc)
            print '<tr bgcolor="%s">' % LineBgColors[ibgcol]
            print '  <td><a href="%s?action=showSection&farm=%s&sid=%s">%s</a></td>' %\
                  (FBSURL, farm, sid, sid)
            state = s.State
            if state == 'waiting':
                if s.HoldTime and (s.HoldTime > time.time() or s.HoldTime == -1):
                    state = 'held'
            try:	color = SectionStateColors[state]
            except: color = SectionStateColors['unknown']
            print '  <td>%s</td>' % s.Username
            print '  <td>%s</td>' %\
                  (s.ProcType)
            print '  <td %s>%s</td><td>%s</td><td>%s</td>' % (
                color, state, s.Prio,nprocstr)
            if state == 'running':
                print '  <td>Started at %s</td>' % atime(s.StartTime)
            elif state in ['ready','waiting']:
                print '  <td>Submitted at %s</td>' % atime(s.SubTime)
            elif state in ['done','failed','zombie','canceled']:
                print '  <td>Ended at %s</td>' % atime(s.EndTime)
            elif state == 'held':
                if s.HoldTime == -1:
                    print '  <td>Held</td>'
                else:
                    print '  <td>Held until %s</td>' % atime(s.HoldTime)
            else:	# ['ready','waiting']
                print '  <td>Submitted at %s</td>' % atime(s.SubTime)
			
            print '</tr>'
    if (nstot == 0):
        print '<tr bgcolor="%s"><td>none</td><td></td><td></td><td></td><td></td><td></td><td></td></tr>' % LineBgColors[ibgcol]

    print '</table>'
    print '<p>'

#---------------------------------------------------------------------------------------------------
def infoQueue():
	print '<table cellpadding=2 width="100%">'
	print '<tr bgcolor="%s"><th>Name</th><th>Status</th><th>Default Process Type</th><th>Share</th><th>Prio</th><th>Waiting</th>' %\
		THBgCol
	print '<th>Ready</th><th>Running</th><th>Total</th></tr>'


	#qnlst = fc.getQueueList()
        #q = fc.getQueue(qn)
	#qlst.append(q)
	
#	maxdec = 0
#	for q in qlst:
#		if q.QPDec > maxdec:
#			maxdec = q.QPDec
	
        qn = user
        nrd = nwt = nrn = ntot = 0
        for sn in q.Sections:
            st = q.SectState[sn]
            if st == 'ready':		nrd = nrd + 1
            elif st == 'waiting':	nwt = nwt + 1
            elif st == 'running':	nrn = nrn + 1
            ntot = ntot + 1
        sts = ''
        bg = "#77FF77"
        #igb = bg#len(LineBgColors)
        if q.IsHeld:
            sts = 'Held'
            bg = "#FFFF77"
        if q.IsLocked:
            bg = "#FF7777"
            if sts:
                sts = sts + '+Locked'
            else:
                sts = sts + 'Locked'
        if not sts: 	sts = 'OK'

        print '<tr bgcolor="%s"><td><a href="%s?action=showQueue&farm=%s&qname=%s">%s</a></td>' %\
              (LineBgColors[0], FBSURL, farm, qn, qn)
        share = '(inf)'
#        if maxdec > 0 and q.QPDec > 0:
#            share = float(maxdec)/float(q.QPDec)
#            share = '%.2f' % share
        print '  <td bgcolor="%s" align="center">%s</td><td>%s</td><td align="right">%s</td><td align="right">%s</td>' % \
              (bg, sts, q.DefProcType, share, q.Prio)
        bgwt = ''
        if nwt > 0:
            bgwt = SectionStateColors['waiting']
        print '  <td %s align="right">%s</td>' % (bgwt, nwt)
        bgrd = ''
        if nrd > 0:
            bgrd = SectionStateColors['ready']
        print '  <td %s align="right">%s</td>' % (bgrd, nrd)
        bgrn = ''
        if nrn > 0:
            bgrn = SectionStateColors['running']
        print '  <td %s align="right">%s</td>' % (bgrn, nrn)		
        print '  <td align="right">%s</td>' % (ntot,)		
        print '</tr>'
        print '</table>'

    
#---------------------------------------------------------------------------
def ParametersTable():
    print '<center><table cellpadding=3 border=0 cellspacing=2 bgcolor=#EEFFDD> <!-- Queue pars -->'
    print '<tr bgcolor="#80DDCB"><td colspan=5 align="center"><b>Queue Parameters</b></td></tr>'
    print '<tr><td align="right">Def. Proc. Type:</td><td colspan=3>%s</td>' % \
	  q.DefProcType
    print '</tr>'
    print '<tr><td align="right">Allowed. Proc. Types:</td><td colspan=3>%s</td>' % \
	  string.join(q.ProcTypes)
    print '</tr>'		
    print '<tr><td align="right">Authorized Users:</td><td colspan=3>%s</td>' % \
	  string.join(q.Users)
    print '</tr>'		
    print '<tr><td align="right">Queue priority:</td><td>%s</td>' % q.Prio
    print '    <td align="right">Min..max:</td><td>%s..%s</td><td></td></tr>' % \
	  (q.MinQPrio, q.MaxQPrio)
    print '<tr><td align="right">Queue priority decrement:</td><td>%s</td>' % \
	  q.QPDec
    print '    <td align="right">gap:</td><td>%s</td><td></td></tr>' % \
	  q.QPGap
    print '<tr><td align="right">Section priority max:</td><td>%s</td>' % \
	  q.MaxSPrio
    print '    <td align="right">gap:</td><td>%s</td><td></td></tr>' % \
	  q.SPGap
    print '<tr><td align="right">Real time limit:</td><td>%s</td>' % \
	  dtime(q.RealTimeLimit)				
    print '    <td align="right">CPU time limit:</td><td>%s</td><td></td></tr>' % \
	  dtime(q.CPUTimeLimit)				
    print '</table></center> <!-- End of queue pars -->'


#---------------------------------------------------------------------------
def atime(t):
	if not t:
		return '(none)'
	else:
		tm = time.localtime(t)
		return '%02d/%02d %02d:%02d:%02d' % tm[1:6]
    
#---------------------------------------------------------------------------
def dtime(t):
	if t < 0 or t == None:
		return '(none)'
	t = int(t)
	if not t:	return '0'
	d = t / (24*3600)
	t = t % (24*3600)
	h = t / 3600
	t = t % 3600
	m = t / 60
	s = t % 60
	if d > 0:
		return '%dd%dh' % (d, h)
	elif h > 0:
		return '%dh%02dm' % (h, m)
	else:
		# minutes + seconds
		return '%dm%02ds' % (m, s)

#---------------------------------------------------------------------------
def main():
    
#    opt = cgi.FieldStorage()
    print 'Content-type: text/html\n\n'
    print '<HTML>'
    print '<HEAD>'
    print '<TITLE>CAF User Monitor</TITLE>'
    print '<META http-equiv="refresh" content="300">'
    print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
    print '</HEAD>'
    
    print '<BODY BGCOLOR="#80DDCB" LINK="#000000" VLINK="#000000" ALINK="#000000">'

    print '<center>'
    print '<h2>User <font color="#FF0000">%s</font> page</h2>' % user
    print '<p></center>'

    print '<P>per1 = %s' % per1
    print '<P>per2 = %s' % per2
    today = time.strftime('%m%d%y', time.localtime(time.time()))

    print '<p>adesso %s' % today


#    miniUserSummaryTable()
    infoQueue()
    CPUusage2()
#    CPUusage3()
#    TimeGraphs(q,period="all")
#    setGraphName()
    SectionsTable()
#    ParametersTable()
    
    print '</BODY></HTML>'

if __name__ == "__main__":
    main()
