#!/usr/bin/python2
########################################################################################

import cgi
import os
import commands
import time
import string
import sys
import random
sys.path.insert(1,"/local/ups/prd/fbsng/v1_4/Linux/lib")
sys.path.insert(1,"/local/ups/prd/fcslib/v2_1/NULL/lib")
sys.path.insert(1,"/export/home/cafmon/fbsmon/scripts")
from mkTimeHistos import Histo
from FBS_API import *

#---------------------------------------------------------------------------
# Global Variables:
#---------------------------------------------------------------------------
DBdir     = "/export/home/cafmon/fbsmon/db"
RRDdir    = "/export/home/cafmon/bin"
GraphDir  = "/caf/users/graphs"
GlobalDir = '/caf/users/global'
FBSNGcfg  = "/home/cdfcaf/CafSetup/fbsng/cfg/fbs.cfg"
fc        = FBSClient('FBSmon',FBSNGcfg)
FBSURL    = "http://cdfcaf.fnal.gov/cgi-bin/fbswww/fbswww"
FBSURL    = "http://cdfcaf.fnal.gov/cgi-bin/fbswww/fbswww"
farm      = "CAF"
opt       = cgi.FieldStorage()
user      = opt["opt"].value
peri1     = opt["per1"].value
peri2     = opt["per2"].value
qname     = user
q         = fc.getQueue(qname)
THBgCol   = '#80cBdD'
LineBgColors = ['#eeeecc','#eeeecc','#eeeecc','#ffffdd','#ffffdd','#ffffdd']
SectionStateColors = {
    'running':'bgcolor="#AAFFAA"',
    'ready':'bgcolor="#DDFF88"',
    'waiting':'bgcolor="#FFDD88"',
    'held':'bgcolor="#88EEEE"',
    'failed':'bgcolor="#DDAA88"',
    'canceled':'bgcolor="#AABBAA"',
    'done':'bgcolor="#AABBAA"',
    'zombie':'bgcolor="#AABBAA"',
    'unknown':''
    }
    
#------------------------------------------------------
def getAvailableNodes():
    nodelist = fc.getNodeList()
    ntot = 0
    for node in nodelist:
        n = fc.getNode(node)
        #print n.Name, n.IsUp, n.Class, n.Resources, n.Processes
        if n.IsUp and n.Class == "worker":
            ntot = ntot+1
    return ntot

#------------------------------------------------------
def CPUgraphc(user,peri1,peri2,type,pnt):

# correction for date in format MMDDYY or MM/DD/YY
    mese = int(peri1[0]+peri1[1])
    if peri1[2]=='/':
        anno = int( "20"+peri1[6]+peri1[7] )
        giorno = int(peri1[3]+peri1[4])
        #data1 = peri1[0]+peri1[1]+"/"+peri1[3]+peri1[4]+"/"+"20" +peri1[6]+peri1[7]
        data1 = peri1[0]+peri1[1]+peri1[3]+peri1[4]+"20"+peri1[6]+peri1[7]
    else:
        anno = int( "20"+peri1[4]+peri1[5])
        giorno = int(peri1[2]+peri1[3])
        #data1 = peri1[0]+peri1[1]+"/"+peri1[2]+peri1[3]+"/"+"20"+peri1[4]+peri1[5]
        data1 = peri1[0]+peri1[1]+peri1[2]+peri1[3]+"20"+peri1[4]+peri1[5]
    n = [ anno, mese, giorno, 0, 0, 0, 0, 0, 0 ]
    aper1 = time.strftime('%s', n )

    mese = int(peri2[0]+peri2[1])
    if peri2[2]=='/':
        anno = int( "20"+peri2[6]+peri2[7] )
        giorno = int(peri2[3]+peri2[4])
        #data2 = peri2[0]+peri2[1]+"/"+peri2[3]+peri2[4]+"/"+"20" +peri2[6]+peri2[7]
        data2 = peri2[0]+peri2[1]+peri2[3]+peri2[4]+"20"+peri2[6]+peri2[7]        
    else:
        anno = int( "20"+peri2[4]+peri2[5])
        giorno = int(peri2[2]+peri2[3])
        #data2 = peri2[0]+peri2[1]+"/"+peri2[2]+peri2[3]+"/"+"20"+peri2[4]+peri2[5]
        data2 = peri2[0]+peri2[1]+peri2[2]+peri2[3]+"20"+peri2[4]+peri2[5]        
#    anno = int( "20"+peri2[4]+peri2[5] )
#    giorno = int(peri2[2]+peri2[3])
#    data2 = peri2[0]+peri2[1]+"/"+peri2[2]+peri2[3]+"/"+"20"+peri2[4]+peri2[5]
    n = [ anno,  mese, giorno, 0, 0, 0, 0, 0, 0 ]
    aper2 = time.strftime('%s', n )


    Nnodes = 2* getAvailableNodes()
    pid =  os.getpid()
    graph   = '%s/graph_%s-%s_%s%d_%s.gif'   % (GraphDir,data1,data2,type,pid,pnt)

    dt = ' -s %s  -e %s' % (aper1,aper2)

#    if period == 'day':
#        dt = ' -s -1d -e N'
#    elif period == 'week':
#        dt = ' -s -1w -e N'
#    elif period == 'month':
#        dt = ' -s -1m -e N'

    str1 = '%s/rrdtool graph /tmp' % RRDdir

    str2 = ' --title "%s-%s ' % (data1,data2)

    if type == 'i':
        str2 = str2 + ' (integrated)"'
        #str4 = ' -v "Percentage of CPU time"'
        str4 = ' -v "used CPU"'
    else:
        str2 = str2 + '"'
        str4 = ' -v "used CPU"'
        #str4 = ' -v "Percentage of used CPUs"'

    if pnt == 1:
        str3 = ' -c BACK#FFFFFF -c CANVAS#FFFFFF -c MGRID#000000  -w  200 -h 120  --units-exponent 0' 
    else:
        str3 = ' -c BACK#000000 -c CANVAS#111133 -c MGRID#CCCCCC -c FONT#00EEBB -w  200 -h 120 --units-exponent 0' 



    str = str1 + graph + str2 + str3 + str4 + dt

    Norm = 1.
    #Norm  = 50. / Nnodes #this normalization is used to get percentage on y-axis 

    INorm = 1.
        
    if type == 'i':
	    str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:i%s=%s,UN,0,%s,IF,PREV,UN,0,PREV,IF,+ CDEF:ii%s=i%s,%s,*  LINE2:ii%s#%s:"%s"' % \
                  (user,user,user,user,user,INorm,user,color(0),user)
    else:
            str = str + ' DEF:%s=%s/queues/%s.rrd:NrT:AVERAGE' % (user,DBdir,user) + \
                  ' CDEF:f%s=%s,%s,* LINE2:f%s#%s:"%s"'  % (user,user,Norm,user,color(1),user)


    commands.getoutput(str)
    #print str
    #print graph
    
    return graph


#---------------------------------------------------------------------
def color(i):
    step = 51
    random.seed(i*10000000)
    R = step * ( int(random.random()*6.) )
    G = step * ( int(random.random()*6.) )
    B = step * ( int(random.random()*6.) )
    return "%02X%02X%02X" % (R,G,B)

#----------------------------------------------------------------------
def CPUusage2():

    print '<center>'
    #    print '<font color="#000099">click on graph for a printable version</font>'
    print '<table border=0 cols="3"<tr>'

    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td>' % \
          (CPUgraphc(user,peri1,peri2,'',1),CPUgraphc(user,peri1,peri2,'',0) )  
    print '<td width="210"> <a href="%s"><img src="%s" border=0></a></td></tr>' % \
          (CPUgraphc(user,peri1,peri2,'i',1),CPUgraphc(user,peri1,peri2,'i',0))
    print '</table>'

    #print 'Built using <a href="http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/" target="_blank">RRDTool</a>'
    print '</center>'

#----------------------------------------------------------------------------------------
def SectionsTable():
    print '<table  width="100%" cellpadding=2>'
    print '<tr bgcolor="%s"><th>SectID</th><th>User</th><th>ProcType</th><th>Status</th><th>Prio</th><th>NProc</th><th>Date/Time</th></tr>' %\
          THBgCol
    ibgcol = -1

    nstot = 0
    for sid in q.Sections:
        nstot = nstot+1
        ibgcol = (ibgcol + 1) % len(LineBgColors)
        s = fc.getSection(sid)
        #if ptype != None and s.ProcType != ptype:
        #    continue
        nrun = 0
        for i in range(s.NProc):
            if s.ProcStats[i+1] == 'running':
                nrun = nrun + 1
            nprocstr = '%s/%s' % (nrun, s.NProc)
            print '<tr bgcolor="%s">' % LineBgColors[ibgcol]
            print '  <td><a href="%s?action=showSection&farm=%s&sid=%s">%s</a></td>' %\
                  (FBSURL, farm, sid, sid)
            state = s.State
            if state == 'waiting':
                if s.HoldTime and (s.HoldTime > time.time() or s.HoldTime == -1):
                    state = 'held'
            try:	color = SectionStateColors[state]
            except: color = SectionStateColors['unknown']
            print '  <td>%s</td>' % s.Username
            print '  <td>%s</td>' %\
                  (s.ProcType)
            print '  <td %s>%s</td><td>%s</td><td>%s</td>' % (
                color, state, s.Prio,nprocstr)
            if state == 'running':
                print '  <td>Started at %s</td>' % atime(s.StartTime)
            elif state in ['ready','waiting']:
                print '  <td>Submitted at %s</td>' % atime(s.SubTime)
            elif state in ['done','failed','zombie','canceled']:
                print '  <td>Ended at %s</td>' % atime(s.EndTime)
            elif state == 'held':
                if s.HoldTime == -1:
                    print '  <td>Held</td>'
                else:
                    print '  <td>Held until %s</td>' % atime(s.HoldTime)
            else:	# ['ready','waiting']
                print '  <td>Submitted at %s</td>' % atime(s.SubTime)
			
            print '</tr>'
    if (nstot == 0):
        print '<tr bgcolor="%s"><td>none</td><td></td><td></td><td></td><td></td><td></td><td></td></tr>' % LineBgColors[ibgcol]

    print '</table>'
    print '<p>'

#---------------------------------------------------------------------------------------------------
def infoQueue():
	print '<table cellpadding=2 width="100%">'
	print '<tr bgcolor="%s"><th>Name</th><th>Status</th><th>Default Process Type</th><th>Share</th><th>Prio</th><th>Waiting</th>' %\
		THBgCol
	print '<th>Ready</th><th>Running</th><th>Total</th></tr>'


	#qnlst = fc.getQueueList()
        #q = fc.getQueue(qn)
	#qlst.append(q)
	
#	maxdec = 0
#	for q in qlst:
#		if q.QPDec > maxdec:
#			maxdec = q.QPDec
	
        qn = user
        nrd = nwt = nrn = ntot = 0
        for sn in q.Sections:
            st = q.SectState[sn]
            if st == 'ready':		nrd = nrd + 1
            elif st == 'waiting':	nwt = nwt + 1
            elif st == 'running':	nrn = nrn + 1
            ntot = ntot + 1
        sts = ''
        bg = "#77FF77"
        #igb = bg#len(LineBgColors)
        if q.IsHeld:
            sts = 'Held'
            bg = "#FFFF77"
        if q.IsLocked:
            bg = "#FF7777"
            if sts:
                sts = sts + '+Locked'
            else:
                sts = sts + 'Locked'
        if not sts: 	sts = 'OK'

        print '<tr bgcolor="%s"><td><a href="%s?action=showQueue&farm=%s&qname=%s">%s</a></td>' %\
              (LineBgColors[0], FBSURL, farm, qn, qn)
        share = '(inf)'
#        if maxdec > 0 and q.QPDec > 0:
#            share = float(maxdec)/float(q.QPDec)
#            share = '%.2f' % share
        print '  <td bgcolor="%s" align="center">%s</td><td>%s</td><td align="right">%s</td><td align="right">%s</td>' % \
              (bg, sts, q.DefProcType, share, q.Prio)
        bgwt = ''
        if nwt > 0:
            bgwt = SectionStateColors['waiting']
        print '  <td %s align="right">%s</td>' % (bgwt, nwt)
        bgrd = ''
        if nrd > 0:
            bgrd = SectionStateColors['ready']
        print '  <td %s align="right">%s</td>' % (bgrd, nrd)
        bgrn = ''
        if nrn > 0:
            bgrn = SectionStateColors['running']
        print '  <td %s align="right">%s</td>' % (bgrn, nrn)		
        print '  <td align="right">%s</td>' % (ntot,)		
        print '</tr>'
        print '</table>'

    
#---------------------------------------------------------------------------
def atime(t):
	if not t:
		return '(none)'
	else:
		tm = time.localtime(t)
		return '%02d/%02d %02d:%02d:%02d' % tm[1:6]
    
#---------------------------------------------------------------------------
def dtime(t):
	if t < 0 or t == None:
		return '(none)'
	t = int(t)
	if not t:	return '0'
	d = t / (24*3600)
	t = t % (24*3600)
	h = t / 3600
	t = t % 3600
	m = t / 60
	s = t % 60
	if d > 0:
		return '%dd%dh' % (d, h)
	elif h > 0:
		return '%dh%02dm' % (h, m)
	else:
		# minutes + seconds
		return '%dm%02ds' % (m, s)

#---------------------------------------------------------------------------
def main():
    
    print 'Content-type: text/html\n\n'
    print '<HTML>'
    print '<HEAD>'
    print '<TITLE>CAF User Monitor</TITLE>'
    print '<META http-equiv="refresh" content="300">'
    print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
    print '</HEAD>'
    
    print '<BODY BGCOLOR="#80DDCB" LINK="#000000" VLINK="#000000" ALINK="#000000">'



    infoQueue()
    CPUusage2()
    SectionsTable()

    
    print '</BODY></HTML>'

if __name__ == "__main__":
    main()
